Package: DNAcopy
Title: DNA Copy Number Data Analysis
Version: 1.86.0
Author: Venkatraman E. Seshan, Adam Olshen
Description: Implements the circular binary segmentation (CBS) 
        algorithm to segment DNA copy number data and identify
        genomic regions with abnormal copy number.
Maintainer: Venkatraman E. Seshan <seshanv@mskcc.org>
LazyData: yes
License: GPL (>= 2)
biocViews: Microarray, CopyNumberVariation
NeedsCompilation: yes
git_url: https://git.bioconductor.org/packages/DNAcopy
git_branch: RELEASE_3_23
git_last_commit: 7901b1e
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-28 21:48:01 UTC; biocbuild

c     new approach to maximizing t-statistic
c     dynamic memory allocation using allocatable arrays 
      subroutine tmaxo(n,x,tss,sx,iseg,ostat,al0,ibin)
      integer n,iseg(2),al0
      double precision x(n),tss,sx(n),ostat
      logical ibin
c     
c     look at the partial sums in blocks of size sqrt(n)
c     
      integer ipsmin, ipsmax, ipsmin0, ipsmax0, nb, i, j, k, l, nb1,
     1     nb2, bi, bj, ilo, ihi, jlo, jhi, alenmax, i2j, sxmxi,
     2     alenlo, alenhi, tmaxi, tmaxj, ixlo, ixhi, nal0
      double precision psum, psmin, psmax, psmin0, psmax0, bssmax,
     1     bsslim, rn, rj, rjhi, rjlo, rnjov1, sij1, sij2, sijmx0,
     2     absx, sxmx, bijbss, rnov2, psdiff
c     
c     use local arrays for working within blocks
c     block partial sum max and min 
      double precision, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:), ibmin(:), ibmax(:)

c     t statistic corresponding to max for block i,j (and max possible)
      double precision, allocatable :: bssbij(:), bssijmax(:)
c     row, column and order vector for reordering bssbij
      integer, allocatable :: bloci(:), blocj(:), loc(:), alen(:)

c     calculate number of blocks (nb) and block boundaries (vector bb)
      rn = dble(n)
      if (n .ge. 50) then
         nb = nint(sqrt(dble(n)))
      else
         nb = 1
      endif

c     the number of paiwise block comparison
      nb2 = nb*(nb+1)/2
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb), ibmin(nb), ibmax(nb))
      allocate(bssbij(nb2), bssijmax(nb2))
      allocate(bloci(nb2), blocj(nb2), loc(nb2), alen(nb2))

c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dble(i)/dble(nb)))
 110  continue

c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      psmin0 = 0
      psmax0 = 0
      ipsmin0 = n
      ipsmax0 = n
      do 20 j = 1, nb
         sx(ilo) = psum + x(ilo)
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + x(i)
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         ibmin(j) = ipsmin
         ibmax(j) = ipsmax
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     adjust global min, max and locations
         if (psmin .lt. psmin0) then
            psmin0 = psmin
            ipsmin0 = ipsmin
         endif
         if (psmax .gt. psmax0) then
            psmax0 = psmax
            ipsmax0 = ipsmax
         endif
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
 20   continue

c     calculate bss for max s_i - min s_i
      psdiff = psmax0 - psmin0
      rj = dble(abs(ipsmax0 - ipsmin0))
      rnjov1 = rn/(rj*(rn-rj))
      if (ibin) then
         bssmax = rnjov1*(psdiff-0.5)**2
      else
         bssmax = rnjov1*psdiff**2
      endif
      tmaxi = min(ipsmax0, ipsmin0)
      tmaxj = max(ipsmax0, ipsmin0)

c     if the segment is all constant then psdiff = 0 and so bssmax = 0
      if (psdiff .le. 0) then
         bssmax = 0
         go to 120
      endif

c     for a pair of blocks (i,j) calculate the max absolute t-statistic
c     at the (min_i, max_j) and (max_i, min_j) locations 
c     for other indices the t-statistic can be bounded using this
c
c     if a block doesn't have the potential to exceed bssmax ignore it
c     calculate the bsslim for each block and include ones >= bssmax

      rnov2 = rn/2
      l = 0
      nal0 = n - al0
      do 40 i = 1, nb
         do 30 j = i, nb
c     calculate bsslim
            if (i .eq. 1) then
               ilo = 1
            else
               ilo = bb(i-1) + 1
            endif
            ihi = bb(i)
            if (j .eq. 1) then
               jlo = 1
            else
               jlo = bb(j-1) + 1
            endif
            jhi = bb(j)
            alenhi = jhi - ilo
            if (alenhi .gt. nal0) alenhi = nal0
            rjhi = dble(alenhi)
            if (i .eq. j) then
               alenlo = 1
            else
               alenlo = jlo - ihi
            endif
            if (alenlo .lt. al0) alenlo = al0
c     max S_k over block j - min S_k over block i
            sij1 = abs(bpsmax(j) - bpsmin(i))
c     max S_k over block i - min S_k over block j
            sij2 = abs(bpsmax(i) - bpsmin(j))
c     if i = j then sij1 and sij2 are the same
            sijmx0 = max(sij1, sij2)
            rjlo = dble(alenlo)
            rnjov1 = rn/min(rjlo*(rn-rjlo), rjhi*(rn-rjhi))
            if (ibin) then
               bsslim = rnjov1*(sijmx0-0.5)**2
            else
               bsslim = rnjov1*(sijmx0**2)
            endif
c     if its as large as bssmax add block
            if (bssmax .le. bsslim) then
               l = l+1
               loc(l) = l
               bloci(l) = i
               blocj(l) = j
               bssijmax(l) = bsslim
c     max sij in the (i,j) block, t-statistic etc
               if (sij1 .gt. sij2) then
                  alen(l) = abs(ibmax(j) - ibmin(i))
                  rj = dble(alen(l))
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bssbij(l) = rnjov1*(sij1-0.5)**2
                  else
                     bssbij(l) = rnjov1*(sij1**2)
                  endif
               else
                  alen(l) = abs(ibmin(j) - ibmax(i))
                  rj = dble(alen(l))
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bssbij(l) = rnjov1*(sij2-0.5)**2
                  else
                     bssbij(l) = rnjov1*(sij2**2)
                  endif
               endif
            endif
 30      continue
 40   continue
      nb1 = l

c     Now sort the t-statistics by their magnitude
      call qsort4(bssbij, loc, 1, nb1)

c     now go through the blocks in reverse order (largest down)
      do 100 l = nb1, 1, -1
         k = loc(l)
c     need to check a block only if it has potential to increase bss
c     rjlo is the smalllest (j-i) in the block and rjhi is the largest
         bsslim = bssijmax(k)
         if (bssmax .le. bsslim) then
c     bi, bj give the block location
            bi = bloci(k)
            bj = blocj(k)
c     max arc length of interest in block
            alenmax = alen(k)
            if (bi .eq. 1) then
               ilo = 1
            else
               ilo = bb(bi-1) + 1
            endif
            ihi = bb(bi)
            if (bj .eq. 1) then
               jlo = 1
            else
               jlo = bb(bj-1) + 1
            endif
            jhi = bb(bj)
            alenhi = jhi - ilo
            if (alenhi .gt. nal0) alenhi = nal0
            rjhi = dble(alenhi)
            if (bi .eq. bj) then
               alenlo = 1
            else
               alenlo = jlo - ihi
            endif
            if (alenlo .lt. al0) alenlo = al0
            rjlo = dble(alenlo)
c
c     if arc length is larger than n/2 make is n - arc length
c
            if (alenmax .gt. n - alenmax) alenmax = n - alenmax
c
c     if alenlo <= n/2 start from (ihi, jlo) and go up
c     if alenhi >= n/2 start from (ilo, jhi) and go down
c
            if ((rjlo .le. rnov2) .and. (alenlo .le. alenmax)) then
               do 60 i2j = alenlo, alenmax
c     excess calcultaions to set range of i
                  ixlo = max(0, jlo - ilo - i2j)
                  ixhi = max(0, ihi + i2j - jhi)
                  sxmx = 0
                  do 55 i = ilo + ixlo, ihi - ixhi
                     j = i+i2j
                     absx = abs(sx(j) - sx(i))
                     if (sxmx .lt. absx) then
                        sxmx = absx
                        sxmxi = i
                     endif
 55               continue
                  rj = dble(i2j)
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bijbss = rnjov1*(sxmx-0.5)**2
                  else
                     bijbss = rnjov1*(sxmx**2)
                  endif
                  if (bijbss .gt. bssmax) then
                     bssmax = bijbss
                     tmaxi = sxmxi
                     tmaxj = sxmxi + i2j
                  endif
 60            continue
            endif
c
c     make arclength n - arc length
c
            alenmax = n - alenmax
            if ((rjhi .ge. rnov2) .and. (alenhi .ge. alenmax)) then
               do 70 i2j = alenhi, alenmax, -1
c     excess calcultaions to set range of i
                  ixlo = max(0, jlo - ilo - i2j)
                  ixhi = max(0, ihi + i2j - jhi)
                  sxmx = 0
                  do 65 i = ilo + ixlo, ihi - ixhi
                     j = i + i2j
                     absx = abs(sx(j) - sx(i))
                     if (sxmx .lt. absx) then
                        sxmx = absx
                        sxmxi = i
                     endif
 65               continue
                  rj = dble(i2j)
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bijbss = rnjov1*(sxmx-0.5)**2
                  else
                     bijbss = rnjov1*(sxmx**2)
                  endif
                  if (bijbss .gt. bssmax) then
                     bssmax = bijbss
                     tmaxi = sxmxi
                     tmaxj = sxmxi + i2j
                  endif
 70            continue
            endif
         endif
 100  continue

 120  if (ibin) then
         if (tss.le.0.0001) tss = 1.0
         bssmax = bssmax/(tss/rn)
      else
         if (tss.le.bssmax+0.0001) tss = bssmax + 1.0
         bssmax = bssmax/((tss-bssmax)/(rn-2.0))
      endif

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb, ibmin, ibmax)
      deallocate(bssbij, bssijmax, bloci, blocj, loc, alen)

      ostat = bssmax
      iseg(1) = tmaxi
      iseg(2) = tmaxj

      return
      end

c     function for calculating the full max t-statistic on permuted data
c     new approach to maximizing t-statistic using allocatable arrays 
      double precision function tmaxp(n,tss,px,sx,al0,ibin)
      integer n,al0
      double precision tss,px(n),sx(n)
      logical ibin
c     
c     look at the partial sums in blocks of size sqrt(n)
c     
      integer ipsmin, ipsmax, ipsmin0, ipsmax0, nb, i, j, k, l, nb1,
     1     nb2, bi, bj, ilo, ihi, jlo, jhi, alenmax, i2j, alenlo,
     2     alenhi, ixlo, ixhi, nal0
      double precision psum, psmin, psmax, psmin0, psmax0, bssmax,
     1     bsslim, rn, rj, rjhi, rjlo, rnjov1, sij1, sij2, sijmx0,
     2     absx, sxmx, bijbss, rnov2, psdiff
c     
c     use local arrays for working within blocks
c     block partial sum max and min 
      double precision, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:), ibmin(:), ibmax(:)

c     t statistic corresponding to max for block i,j (and max possible)
      double precision, allocatable :: bssbij(:), bssijmax(:)
c     row, column and order vector for reordering bssbij
      integer, allocatable :: bloci(:), blocj(:), loc(:), alen(:)

c     calculate number of blocks (nb) and block boundaries (vector bb)
      rn = dble(n)
      if (n .ge. 50) then
         nb = nint(sqrt(dble(n)))
      else
         nb = 1
      endif

c     the number of paiwise block comparison
      nb2 = nb*(nb+1)/2
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb), ibmin(nb), ibmax(nb))
      allocate(bssbij(nb2), bssijmax(nb2))
      allocate(bloci(nb2), blocj(nb2), loc(nb2), alen(nb2))

c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dble(i)/dble(nb)))
 110  continue

c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      psmin0 = 0
      psmax0 = 0
      ipsmin0 = n
      ipsmax0 = n
      do 20 j = 1, nb
         sx(ilo) = psum + px(ilo)
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + px(i)
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         ibmin(j) = ipsmin
         ibmax(j) = ipsmax
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     adjust global min, max and locations
         if (psmin .lt. psmin0) then
            psmin0 = psmin
            ipsmin0 = ipsmin
         endif
         if (psmax .gt. psmax0) then
            psmax0 = psmax
            ipsmax0 = ipsmax
         endif
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
 20   continue

c     calculate bss for max s_i - min s_i
      psdiff = psmax0 - psmin0
      rj = dble(abs(ipsmax0 - ipsmin0))
      rnjov1 = rn/(rj*(rn-rj))
      if (ibin) then
         bssmax = rnjov1*(psdiff-0.5)**2
      else
         bssmax = rnjov1*psdiff**2
      endif

c     for a pair of blocks (i,j) calculate the max absolute t-statistic
c     at the (min_i, max_j) and (max_i, min_j) locations 
c     for other indices the t-statistic can be bounded using this
c
c     if a block doesn't have the potential to exceed bssmax ignore it
c     calculate the bsslim for each block and include ones >= bssmax

      rnov2 = rn/2
      l = 0
      nal0 = n - al0
      do 40 i = 1, nb
         do 30 j = i, nb
c     calculate bsslim
            if (i .eq. 1) then
               ilo = 1
            else
               ilo = bb(i-1) + 1
            endif
            ihi = bb(i)
            if (j .eq. 1) then
               jlo = 1
            else
               jlo = bb(j-1) + 1
            endif
            jhi = bb(j)
            alenhi = jhi - ilo
            if (alenhi .gt. nal0) alenhi = nal0
            rjhi = dble(alenhi)
            if (i .eq. j) then
               alenlo = 1
            else
               alenlo = jlo - ihi
            endif
            if (alenlo .lt. al0) alenlo = al0
c     max S_k over block j - min S_k over block i
            sij1 = abs(bpsmax(j) - bpsmin(i))
c     max S_k over block i - min S_k over block j
            sij2 = abs(bpsmax(i) - bpsmin(j))
c     if i = j then sij1 and sij2 are the same
            sijmx0 = max(sij1, sij2)
            rjlo = dble(alenlo)
            rnjov1 = rn/min(rjlo*(rn-rjlo), rjhi*(rn-rjhi))
            if (ibin) then
               bsslim = rnjov1*(sijmx0-0.5)**2
            else
               bsslim = rnjov1*(sijmx0**2)
            endif
c     if its as large as bssmax add block
            if (bssmax .le. bsslim) then
               l = l+1
               loc(l) = l
               bloci(l) = i
               blocj(l) = j
               bssijmax(l) = bsslim
c     max sij in the (i,j) block, t-statistic etc
               if (sij1 .gt. sij2) then
                  alen(l) = abs(ibmax(j) - ibmin(i))
                  rj = dble(alen(l))
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bssbij(l) = rnjov1*(sij1-0.5)**2
                  else
                     bssbij(l) = rnjov1*(sij1**2)
                  endif
               else
                  alen(l) = abs(ibmin(j) - ibmax(i))
                  rj = dble(alen(l))
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bssbij(l) = rnjov1*(sij2-0.5)**2
                  else
                     bssbij(l) = rnjov1*(sij2**2)
                  endif
               endif
            endif
 30      continue
 40   continue
      nb1 = l

c     Now sort the t-statistics by their magnitude
      call qsort4(bssbij, loc, 1, nb1)

c     now go through the blocks in reverse order (largest down)
      do 100 l = nb1, 1, -1
         k = loc(l)
c     need to check a block only if it has potential to increase bss
c     rjlo is the smalllest (j-i) in the block and rjhi is the largest
         bsslim = bssijmax(k)
         if (bssmax .le. bsslim) then
c     bi, bj give the block location
            bi = bloci(k)
            bj = blocj(k)
c     max arc length of interest in block
            alenmax = alen(k)
            if (bi .eq. 1) then
               ilo = 1
            else
               ilo = bb(bi-1) + 1
            endif
            ihi = bb(bi)
            if (bj .eq. 1) then
               jlo = 1
            else
               jlo = bb(bj-1) + 1
            endif
            jhi = bb(bj)
            alenhi = jhi - ilo
            if (alenhi .gt. nal0) alenhi = nal0
            rjhi = dble(alenhi)
            if (bi .eq. bj) then
               alenlo = 1
            else
               alenlo = jlo - ihi
            endif
            if (alenlo .lt. al0) alenlo = al0
            rjlo = dble(alenlo)
c
c     if arc length is larger than n/2 make is n - arc length
c
            if (alenmax .gt. n - alenmax) alenmax = n - alenmax
c
c     if alenlo <= n/2 start from (ihi, jlo) and go up
c     if alenhi >= n/2 start from (ilo, jhi) and go down
c
            if ((rjlo .le. rnov2) .and. (alenlo .le. alenmax)) then
               do 60 i2j = alenlo, alenmax
c     excess calcultaions to set range of i
                  ixlo = max(0, jlo - ilo - i2j)
                  ixhi = max(0, ihi + i2j - jhi)
                  sxmx = 0
                  do 55 i = ilo + ixlo, ihi - ixhi
                     j = i+i2j
                     absx = abs(sx(j) - sx(i))
                     if (sxmx .lt. absx) sxmx = absx
 55               continue
                  rj = dble(i2j)
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bijbss = rnjov1*(sxmx-0.5)**2
                  else
                     bijbss = rnjov1*(sxmx**2)
                  endif
                  if (bijbss .gt. bssmax) bssmax = bijbss
 60            continue
            endif
c
c     make arclength n - arc length
c
            alenmax = n - alenmax
            if ((rjhi .ge. rnov2) .and. (alenhi .ge. alenmax)) then
               do 70 i2j = alenhi, alenmax, -1
c     excess calcultaions to set range of i
                  ixlo = max(0, jlo - ilo - i2j)
                  ixhi = max(0, ihi + i2j - jhi)
                  sxmx = 0
                  do 65 i = ilo + ixlo, ihi - ixhi
                     j = i + i2j
                     absx = abs(sx(j) - sx(i))
                     if (sxmx .lt. absx) sxmx = absx
 65               continue
                  rj = dble(i2j)
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bijbss = rnjov1*(sxmx-0.5)**2
                  else
                     bijbss = rnjov1*(sxmx**2)
                  endif
                  if (bijbss .gt. bssmax) bssmax = bijbss
 70            continue
            endif
         endif
 100  continue

      if (ibin) then
         if (tss.le.0.0001) tss = 1.0
         tmaxp = bssmax/(tss/rn)
      else
         if (tss.le.bssmax+0.0001) tss = bssmax + 1.0
         tmaxp = bssmax/((tss-bssmax)/(rn-2.0))
      endif

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb, ibmin, ibmax)
      deallocate(bssbij, bssijmax, bloci, blocj, loc, alen)

      return
      end

c     function for the max (over small arcs) t-statistic on permuted data
c     new code to speed up this part 3/31/2010
      double precision function htmaxp(n,k,tss,px,sx,al0,ibin)
      integer n,k,al0
      double precision tss,px(n),sx(n)
      logical ibin

      integer i, j, nmj
      double precision rn, rj, absx, sxmx, bssmx, psmin, psmax, psdiff,
     1     bsslim, rnjov1

c     create blocks of size k (or k+1) to span 1 thru n
c     block partial sum max and min 
      double precision, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:)
c     variables to work on block specific data
      integer nb, ilo, ihi, l
      double precision psum, psdiffsq

      rn = dble(n)
c     number of blocks of size k (plus fraction since n/k may not be integer)
      nb = int(rn/dble(k))
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb))
c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dble(i)/dble(nb)))
 110  continue

c     don't need global min and max
c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      htmaxp = 0.0d0
      do 20 j = 1, nb
         sx(ilo) = psum + px(ilo)
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + px(i)
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
c     calculate the bss at the block max & min pr
         i = abs(ipsmin - ipsmax)
         if ((i .le. k) .and. (i .ge. al0)) then
            rj = dble(i)
            rnjov1 = rn/(rj*(rn-rj))
            if (ibin) then
               bssmx = rnjov1*(bpsmax(j) - bpsmin(j) -0.5)**2
            else
               bssmx = rnjov1*(bpsmax(j) - bpsmin(j))**2
            endif
            if (htmaxp .lt. bssmx) htmaxp = bssmx
         endif
 20   continue

c     check the first block
      ilo = 1
      ihi = bb(1)
      psdiff = bpsmax(1) - bpsmin(1)
      if (ibin) then
         psdiffsq = (psdiff-0.5)**2
      else
         psdiffsq = psdiff**2
      endif
      do 40 j = al0,k
         rj = dble(j)
         rnjov1 = rn/(rj*(rn-rj))
         bsslim = rnjov1*psdiffsq
         if (bsslim .lt. htmaxp) go to 50
         sxmx = 0.0d0
         do 30 i = ilo,ihi-j
            absx = abs(sx(i+j) - sx(i))
            if (sxmx.lt.absx) sxmx = absx
 30      continue
         if (ibin) then
            bssmx = rnjov1*(abs(sxmx)-0.5)**2
         else
            bssmx = rnjov1*sxmx**2
         endif
         if (htmaxp.lt.bssmx) htmaxp = bssmx
 40   continue

c     now the minor arcs spanning the end (n)
 50   psdiff = max(abs(bpsmax(1)-bpsmin(nb)), abs(bpsmax(nb)-bpsmin(1)))
      if (ibin) then
         psdiffsq = (psdiff-0.5)**2
      else
         psdiffsq = psdiff**2
      endif
      do 70 j = al0,k
         rj = dble(j)
         rnjov1 = rn/(rj*(rn-rj))
         bsslim = rnjov1*psdiffsq
         if (bsslim .lt. htmaxp) go to 100
         sxmx = 0.0d0
         nmj = n-j
         do 60 i = 1,j
            absx = abs(sx(i+nmj) - sx(i))
            if (sxmx.lt.absx) sxmx = absx
 60      continue
         if (ibin) then
            bssmx = rnjov1*(abs(sxmx)-0.5)**2
         else
            bssmx = rnjov1*sxmx**2
         endif
         if (htmaxp.lt.bssmx) htmaxp = bssmx
 70   continue

c     now the other blocks
 100  do 200 l = 2,nb
         ilo = bb(l-1)+1
         ihi = bb(l)
         psdiff = bpsmax(l) - bpsmin(l)
         if (ibin) then
            psdiffsq = (psdiff-0.5)**2
         else
            psdiffsq = psdiff**2
         endif
         do 140 j = al0,k
            rj = dble(j)
            rnjov1 = rn/(rj*(rn-rj))
            bsslim = rnjov1*psdiffsq
            if (bsslim .lt. htmaxp) go to 150
            sxmx = 0.0d0
            do 130 i = ilo,ihi-j
               absx = abs(sx(i+j) - sx(i))
               if (sxmx.lt.absx) sxmx = absx
 130        continue
            if (ibin) then
               bssmx = rnjov1*(abs(sxmx)-0.5)**2
            else
               bssmx = rnjov1*sxmx**2
            endif
            if (htmaxp.lt.bssmx) htmaxp = bssmx
 140     continue
 150     psdiff = max(abs(bpsmax(l)-bpsmin(l-1)), 
     1        abs(bpsmax(l-1)-bpsmin(l)))
         if (ibin) then
            psdiffsq = (psdiff-0.5)**2
         else
            psdiffsq = psdiff**2
         endif
         do 170 j = al0,k
            rj = dble(j)
            rnjov1 = rn/(rj*(rn-rj))
            bsslim = rnjov1*psdiffsq
            if (bsslim .lt. htmaxp) go to 200
            sxmx = 0.0d0
            nmj = n-j
            do 160 i = ilo-j,ilo-1
               absx = abs(sx(i+j) - sx(i))
               if (sxmx.lt.absx) sxmx = absx
 160        continue
            if (ibin) then
               bssmx = rnjov1*(abs(sxmx)-0.5)**2
            else
               bssmx = rnjov1*sxmx**2
            endif
            if (htmaxp.lt.bssmx) htmaxp = bssmx
 170     continue
 200  continue
      if (ibin) then
         if (tss .le. 0.0001d0) tss = 1.0d0
         htmaxp = htmaxp/(tss/rn)
      else
         if (tss .le. htmaxp+0.0001d0) tss = htmaxp + 1.0d0
         htmaxp = htmaxp/((tss-htmaxp)/(rn-2.0d0))
      endif

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb)

      return
      end

c     these are the subroutines to do the weigthed version of CBS
c     which is useful in order to merge data from multiple platforms
c     --------------------------------------------------------------
c         This is relevant only for log-ratio not binary data
c     --------------------------------------------------------------
c     function for calculating the full max weighted t-statistic
c     new approach to maximizing t-statistic

      subroutine wtmaxo(n,x,wts,tss,sx,cwts,iseg,ostat,al0)
      integer n,iseg(2),al0
      double precision x(n),wts(n),tss,sx(n),cwts(n),ostat
c     
c     look at the partial sums in blocks of size sqrt(n)
c     
      integer ipsmin, ipsmax, ipsmin0, ipsmax0, nb, i, j, k, l, nb1,
     1     nb2, bi, bj, ilo, ihi, jlo, jhi, ihi1, jlo1, jhi1,
     2     tmaxi, tmaxj, nal0
      double precision psum, psmin, psmax, psmin0, psmax0, bssmax,
     1     bsslim, rn, sij1, sij2, sijmx0, bijbss, awtmax, psrnov2,
     2     psdiff, psrj, psrn, psrnj, awtlo, awthi, awt1
c     
c     use local arrays for working within blocks
c     block partial sum max and min 
      double precision, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:), ibmin(:), ibmax(:)

c     t statistic corresponding to max for block i,j
      double precision, allocatable :: bssbij(:), bssijmax(:), awt(:)
c     row, column and order vector for reordering bssbij
      integer, allocatable :: bloci(:), blocj(:), loc(:)

c     calculate number of blocks (nb) and block boundaries (vector bb)
      rn = dble(n)
      if (n .ge. 50) then
         nb = nint(sqrt(dble(n)))
      else
         nb = 1
      endif

c     the number of paiwise block comparison
      nb2 = nb*(nb+1)/2
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb), ibmin(nb), ibmax(nb))
      allocate(bssbij(nb2), bssijmax(nb2), awt(nb2))
      allocate(bloci(nb2), blocj(nb2), loc(nb2))

c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dble(i)/dble(nb)))
 110  continue

c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      psmin0 = 0
      psmax0 = 0
      ipsmin0 = n
      ipsmax0 = n
      do 20 j = 1, nb
         sx(ilo) = psum + x(ilo)*wts(ilo)
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + x(i)*wts(i)
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         ibmin(j) = ipsmin
         ibmax(j) = ipsmax
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     adjust global min, max and locations
         if (psmin .lt. psmin0) then
            psmin0 = psmin
            ipsmin0 = ipsmin
         endif
         if (psmax .gt. psmax0) then
            psmax0 = psmax
            ipsmax0 = ipsmax
         endif
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
 20   continue

c     calculate bss for max s_i - min s_i
      psdiff = psmax0 - psmin0
c     if the segment is all constant then psdiff = 0 and so bssmax = 0
      if (psdiff .le. 0) then
         bssmax = 0
         go to 120
      endif
      psrn = cwts(n)
      psrj = abs(cwts(ipsmax0) - cwts(ipsmin0))
      psrnj = psrj*(psrn-psrj)
      bssmax = (psdiff**2)/psrnj
      tmaxi = min(ipsmax0, ipsmin0)
      tmaxj = max(ipsmax0, ipsmin0)

c     for a pair of blocks (i,j) calculate the max absolute t-statistic
c     at the (min_i, max_j) and (max_i, min_j) locations 
c     for other indices the t-statistic can be bounded using this
c
c     if a block doesn't have the potential to exceed bssmax ignore it
c     calculate the bsslim for each block and include ones >= bssmax

      psrnov2 = psrn/2
      l = 0
      nal0 = n - al0
      do 40 i = 1, nb
         do 30 j = i, nb
c     calculate bsslim
            if (i .eq. 1) then
               ilo = 1
            else
               ilo = bb(i-1) + 1
            endif
            ihi = bb(i)
            if (j .eq. 1) then
               jlo = 1
            else
               jlo = bb(j-1) + 1
            endif
            jhi = bb(j)
c     for wCBS calculated hi and lo arc weights instead of lengths
            awthi = cwts(jhi) - cwts(ilo)
            if (jhi - ilo .gt. nal0) then
               awthi = 0
               do 35 k = 1, al0
                  awthi = max(awthi, cwts(nal0+k) - cwts(k))
 35            continue
            endif
            if (i .eq. j) then
               awtlo = cwts(ilo+al0) - cwts(ilo)
               do 36 k = ilo + 1, ihi - al0
                  awtlo = min(awtlo, cwts(k+al0) - cwts(k))
 36            continue
            else if (i+1 .eq. j) then
               awtlo = cwts(jlo) - cwts(jlo-al0)
               do 37 k = jlo - al0 + 1, ihi
                  awtlo = min(awtlo, cwts(k+al0) - cwts(k))
 37            continue
            else
               awtlo = cwts(jlo) - cwts(ihi)
            endif
c     max S_k over block j - min S_k over block i
            sij1 = abs(bpsmax(j) - bpsmin(i))
c     max S_k over block i - min S_k over block j
            sij2 = abs(bpsmax(i) - bpsmin(j))
c     if i = j then sij1 and sij2 are the same
            sijmx0 = max(sij1, sij2)
            psrnj = min(awtlo*(psrn-awtlo), awthi*(psrn-awthi))
            bsslim = (sijmx0**2)/psrnj
c     if its as large as bssmax add block
            if (bssmax .le. bsslim) then
               l = l+1
               loc(l) = l
               bloci(l) = i
               blocj(l) = j
               bssijmax(l) = bsslim
c     max sij in the (i,j) block, t-statistic etc
               if (sij1 .gt. sij2) then
                  awt(l) = abs(cwts(ibmax(j)) - cwts(ibmin(i)))
                  bssbij(l) = (sij1**2)/(awt(l)*(psrn-awt(l)))
               else
                  awt(l) = abs(cwts(ibmin(j)) - cwts(ibmax(i)))
                  bssbij(l) = (sij2**2)/(awt(l)*(psrn-awt(l)))
               endif
            endif
 30      continue
 40   continue

      nb1 = l

c     Now sort the t-statistics by their magnitude
      call qsort4(bssbij, loc, 1, nb1)

c     now go through the blocks in reverse order (largest down)
      do 100 l = nb1, 1, -1
         k = loc(l)
c     need to check a block only if it has potential to increase bss
c     rjlo is the smalllest (j-i) in the block and rjhi is the largest
         bsslim = bssijmax(k)
         if (bssmax .le. bsslim) then
c     bi, bj give the block location
            bi = bloci(k)
            bj = blocj(k)
            awtmax = awt(k)
            if (bi .eq. 1) then
               ilo = 1
            else
               ilo = bb(bi-1) + 1
            endif
            ihi = bb(bi)
            if (bj .eq. 1) then
               jlo = 1
            else
               jlo = bb(bj-1) + 1
            endif
            jhi = bb(bj)
            awthi = cwts(jhi) - cwts(ilo)
            if (bi .eq. bj) then
               awtlo = 0
            else
               awtlo = cwts(jlo) - cwts(ihi)
            endif
c
c     if arc wt is larger than half total wt (psrn/2) make is psrn - arc wt
c
            if (awtmax .gt. psrn - awtmax) awtmax = psrn - awtmax
c
c     if awtlo <= psrn/2 start from (ihi, jlo) and go up
c     if awthi >= psrn/2 start from (ilo, jhi) and go down
c
            if (awtlo .le. psrnov2) then
               if (bi .eq.bj) then 
                  ihi1 = ihi - al0
               else
                  ihi1 = ihi
               endif
               do 60 i = ihi1, ilo, -1
                  jlo1 = max(i + al0, jlo)
                  do 55 j = jlo1, jhi
                     awt1 = cwts(j) - cwts(i)
                     if (awt1 .le. awtmax) then
                        bijbss = (sx(j) - sx(i))**2/(awt1*(psrn-awt1))
                        if (bijbss .gt. bssmax) then
                           bssmax = bijbss
                           tmaxi = i
                           tmaxj = j
                        endif
                     endif
 55               continue
 60            continue
            endif
c
c     make arc wt  psrn - arc wt
c
            awtmax = psrn - awtmax
            if (awthi .ge. psrnov2) then
               do 70 i = ilo, ihi
                  if ((bi .eq. 1) .and. (bj .eq. nb)) then 
                     jhi1 = min(jhi, jhi - al0 + i)
                  else
                     jhi1 = jhi
                  endif
                  do 65 j = jhi1, jlo, -1
                     awt1 = cwts(j) - cwts(i)
                     if (awt1 .ge. awtmax) then
                        bijbss = (sx(j) - sx(i))**2/(awt1*(psrn-awt1))
                        if (bijbss .gt. bssmax) then
                           bssmax = bijbss
                           tmaxi = i
                           tmaxj = j
                        endif
                     endif
 65               continue
 70            continue
            endif
         endif
 100  continue

 120  if (tss.le.bssmax+0.0001) tss = bssmax + 1.0
      bssmax = bssmax/((tss-bssmax)/(rn-2.0))

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb, ibmin, ibmax)
      deallocate(bssbij, bssijmax, bloci, blocj, loc, awt)

      ostat = bssmax
      iseg(1) = tmaxi
      iseg(2) = tmaxj

      return
      end

c     function for calculating the full max wtd t-statistic on permuted data
c     using a new approach to maximizing t-statistic
      double precision function wtmaxp(n,px,wts,sx,cwts,al0)
      integer n,al0
      double precision px(n),wts(n),sx(n),cwts(n)
c     
c     look at the partial sums in blocks of size sqrt(n)
c     
      integer ipsmin, ipsmax, ipsmin0, ipsmax0, nb, i, j, k, l, nb1,
     1     nb2, bi, bj, ilo, ihi, jlo, jhi, ihi1, jlo1, jhi1, nal0
      double precision psum, psmin, psmax, psmin0, psmax0, bssmax,
     1     bsslim, rn, sij1, sij2, sijmx0, bijbss, awtmax, psrnov2,
     2     psdiff, psrj, psrn, psrnj, awtlo, awthi, awt1, ssq, tss
c     
c     use local arrays for working within blocks
c     block partial sum max and min 
      double precision, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:), ibmin(:), ibmax(:)

c     t statistic corresponding to max for block i,j
      double precision, allocatable :: bssbij(:), bssijmax(:), awt(:)
c     row, column and order vector for reordering bssbij
      integer, allocatable :: bloci(:), blocj(:), loc(:)

c     calculate number of blocks (nb) and block boundaries (vector bb)
      rn = dble(n)
      if (n .ge. 50) then
         nb = nint(sqrt(dble(n)))
      else
         nb = 1
      endif

c     the number of paiwise block comparison
      nb2 = nb*(nb+1)/2
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb), ibmin(nb), ibmax(nb))
      allocate(bssbij(nb2), bssijmax(nb2), awt(nb2))
      allocate(bloci(nb2), blocj(nb2), loc(nb2))

c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dble(i)/dble(nb)))
 110  continue

c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      psmin0 = 0
      psmax0 = 0
      ipsmin0 = n
      ipsmax0 = n
      ssq = 0
      do 20 j = 1, nb
         sx(ilo) = psum + px(ilo)*wts(ilo)
         ssq = ssq + (px(ilo)**2)*wts(ilo)
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + px(i)*wts(i)
            ssq = ssq + (px(i)**2)*wts(i)
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         ibmin(j) = ipsmin
         ibmax(j) = ipsmax
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     adjust global min, max and locations
         if (psmin .lt. psmin0) then
            psmin0 = psmin
            ipsmin0 = ipsmin
         endif
         if (psmax .gt. psmax0) then
            psmax0 = psmax
            ipsmax0 = ipsmax
         endif
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
 20   continue

c     calculate bss for max s_i - min s_i
      psdiff = psmax0 - psmin0
      psrn = cwts(n)
      tss = ssq - (sx(n)/psrn)**2
      psrj = abs(cwts(ipsmax0) - cwts(ipsmin0))
      psrnj = psrj*(psrn-psrj)
      bssmax = (psdiff**2)/psrnj

c     for a pair of blocks (i,j) calculate the max absolute t-statistic
c     at the (min_i, max_j) and (max_i, min_j) locations 
c     for other indices the t-statistic can be bounded using this
c
c     if a block doesn't have the potential to exceed bssmax ignore it
c     calculate the bsslim for each block and include ones >= bssmax

      psrnov2 = psrn/2
      l = 0
      nal0 = n - al0
      do 40 i = 1, nb
         do 30 j = i, nb
c     calculate bsslim
            if (i .eq. 1) then
               ilo = 1
            else
               ilo = bb(i-1) + 1
            endif
            ihi = bb(i)
            if (j .eq. 1) then
               jlo = 1
            else
               jlo = bb(j-1) + 1
            endif
            jhi = bb(j)
c     for wCBS calculated hi and lo arc weights instead of lengths
            awthi = cwts(jhi) - cwts(ilo)
            if (jhi - ilo .gt. nal0) then
               awthi = 0
               do 35 k = 1, al0
                  awthi = max(awthi, cwts(nal0+k) - cwts(k))
 35            continue
            endif
            if (i .eq. j) then
               awtlo = cwts(ilo+al0) - cwts(ilo)
               do 36 k = ilo + 1, ihi - al0
                  awtlo = min(awtlo, cwts(k+al0) - cwts(k))
 36            continue
            else if (i+1 .eq. j) then
               awtlo = cwts(jlo) - cwts(jlo-al0)
               do 37 k = jlo - al0 + 1, ihi
                  awtlo = min(awtlo, cwts(k+al0) - cwts(k))
 37            continue
            else
               awtlo = cwts(jlo) - cwts(ihi)
            endif
c     max S_k over block j - min S_k over block i
            sij1 = abs(bpsmax(j) - bpsmin(i))
c     max S_k over block i - min S_k over block j
            sij2 = abs(bpsmax(i) - bpsmin(j))
c     if i = j then sij1 and sij2 are the same
            sijmx0 = max(sij1, sij2)
            psrnj = min(awtlo*(psrn-awtlo), awthi*(psrn-awthi))
            bsslim = (sijmx0**2)/psrnj
c     if its as large as bssmax add block
            if (bssmax .le. bsslim) then
               l = l+1
               loc(l) = l
               bloci(l) = i
               blocj(l) = j
               bssijmax(l) = bsslim
c     max sij in the (i,j) block, t-statistic etc
               if (sij1 .gt. sij2) then
                  awt(l) = abs(cwts(ibmax(j)) - cwts(ibmin(i)))
                  bssbij(l) = (sij1**2)/(awt(l)*(psrn-awt(l)))
               else
                  awt(l) = abs(cwts(ibmin(j)) - cwts(ibmax(i)))
                  bssbij(l) = (sij2**2)/(awt(l)*(psrn-awt(l)))
               endif
            endif
 30      continue
 40   continue
      nb1 = l

c     Now sort the t-statistics by their magnitude
      call qsort4(bssbij, loc, 1, nb1)

c     now go through the blocks in reverse order (largest down)
      do 100 l = nb1, 1, -1
         k = loc(l)
c     need to check a block only if it has potential to increase bss
c     rjlo is the smalllest (j-i) in the block and rjhi is the largest
         bsslim = bssijmax(k)
         if (bssmax .le. bsslim) then
c     bi, bj give the block location
            bi = bloci(k)
            bj = blocj(k)
            awtmax = awt(k)
            if (bi .eq. 1) then
               ilo = 1
            else
               ilo = bb(bi-1) + 1
            endif
            ihi = bb(bi)
            if (bj .eq. 1) then
               jlo = 1
            else
               jlo = bb(bj-1) + 1
            endif
            jhi = bb(bj)
            awthi = cwts(jhi) - cwts(ilo)
            if (bi .eq. bj) then
               awtlo = 0
            else
               awtlo = cwts(jlo) - cwts(ihi)
            endif
c
c     if arc wt is larger than half total wt (psrn/2) make is psrn - arc wt
c
            if (awtmax .gt. psrn - awtmax) awtmax = psrn - awtmax
c
c     if awtlo <= psrn/2 start from (ihi, jlo) and go up
c     if awthi >= psrn/2 start from (ilo, jhi) and go down
c
            if (awtlo .le. psrnov2) then
               if (bi .eq.bj) then 
                  ihi1 = ihi - al0
               else
                  ihi1 = ihi
               endif
               do 60 i = ihi1, ilo, -1
                  jlo1 = max(i + al0, jlo)
                  do 55 j = jlo1, jhi
                     awt1 = cwts(j) - cwts(i)
                     if (awt1 .le. awtmax) then
                        bijbss = (sx(j) - sx(i))**2/(awt1*(psrn-awt1))
                        if (bijbss .gt. bssmax) bssmax = bijbss
                     endif
 55               continue
 60            continue
            endif
c
c     make arc wt  psrn - arc wt
c
            awtmax = psrn - awtmax
            if (awthi .ge. psrnov2) then
               do 70 i = ilo, ihi
                  if ((bi .eq. 1) .and. (bj .eq. nb)) then 
                     jhi1 = min(jhi, jhi - al0 + i)
                  else
                     jhi1 = jhi
                  endif
                  do 65 j = jhi1, jlo, -1
                     awt1 = cwts(j) - cwts(i)
                     if (awt1 .ge. awtmax) then
                        bijbss = (sx(j) - sx(i))**2/(awt1*(psrn-awt1))
                        if (bijbss .gt. bssmax) bssmax = bijbss
                     endif
 65               continue
 70            continue
            endif
         endif
 100  continue

      if (tss.le.bssmax+0.0001) tss = bssmax + 1.0
      wtmaxp = bssmax/((tss-bssmax)/(rn-2.0))

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb, ibmin, ibmax)
      deallocate(bssbij, bssijmax, bloci, blocj, loc, awt)

      return
      end

c     function for the max (over small arcs) wtd t-statistic on permuted data
c     new code to speed up this part 4/1/2010
      double precision function hwtmaxp(n,k,px,wts,sx,cwts,mncwt,al0)
      integer n,k,al0
      double precision px(n),wts(n),sx(n),cwts(n),mncwt(k)

      integer i, j, nmj, ipj, ipnmj
      double precision rn, rj, rnj, bssmax, bssij, psmin, psmax, psdiff,
     1     bsslim, ssq, tss

c     create blocks of size k (or k+1) to span 1 thru n
c     block partial sum max and min 
      double precision, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:)
c     variables to work on block specific data
      integer nb, ilo, ihi, l
      double precision psum, psdiffsq

      rn = dble(n)
c     number of blocks
      nb = int(rn/dble(k))
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb))
c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dble(i)/dble(nb)))
 110  continue

c     don't need global min and max
c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      ssq = 0.0d0
      bssmax = 0.0d0
      rn = cwts(n)
      do 20 j = 1, nb
         sx(ilo) = psum + px(ilo)*wts(ilo)
         ssq = ssq + wts(ilo)*px(ilo)**2
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + px(i)*wts(i)
            ssq = ssq + wts(i)*px(i)**2
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
c     calculate the bss at the block max & min pr
         i = abs(ipsmin - ipsmax)
         if ((i .le. k) .and. (i .ge. al0)) then
            rj = abs(cwts(ipsmax) - cwts(ipsmin))
            rnj = rj*(rn-rj)
            bssij = (bpsmax(j) - bpsmin(j))**2/rnj
            if (bssmax .lt. bssij) bssmax = bssij
         endif
 20   continue
      tss = ssq - (sx(n)/rn)**2

c     check the first block
      ilo = 1
      ihi = bb(1)
      psdiff = bpsmax(1) - bpsmin(1)
      psdiffsq = psdiff**2
      do 40 j = al0,k
         rj = mncwt(j)
         bsslim = psdiffsq/(rj*(rn-rj))
         if (bsslim .lt. bssmax) go to 50
         sxmx = 0.0d0
         do 30 i = ilo,ihi-j
            ipj = i+j
            rj = cwts(ipj) - cwts(i)
            bssij = (sx(ipj) - sx(i))**2/(rj*(rn-rj))
            if (bssij .gt. bssmax) bssmax = bssij
 30      continue
 40   continue

c     now the minor arcs spanning the end (n)
 50   psdiff = max(abs(bpsmax(1)-bpsmin(nb)), abs(bpsmax(nb)-bpsmin(1)))
      psdiffsq = psdiff**2
      do 70 j = al0,k
         rj = mncwt(j)
         bsslim = psdiffsq/(rj*(rn-rj))
         if (bsslim .lt. bssmax) go to 100
         nmj = n-j
         do 60 i = 1,j
            ipnmj = i + nmj
            rj = cwts(ipnmj) - cwts(i)
            bssij = (sx(ipnmj) - sx(i))**2/(rj*(rn-rj))
            if (bssij .gt. bssmax) bssmax = bssij
 60      continue
 70   continue

c     now the other blocks
 100  do 200 l = 2,nb
         ilo = bb(l-1)+1
         ihi = bb(l)
         psdiff = bpsmax(l) - bpsmin(l)
         psdiffsq = psdiff**2
         do 140 j = al0,k
            rj = mncwt(j)
            bsslim = psdiffsq/(rj*(rn-rj))
            if (bsslim .lt. bssmax) go to 150
            sxmx = 0.0d0
            do 130 i = ilo,ihi-j
               ipj = i+j
               rj = cwts(ipj) - cwts(i)
               bssij = (sx(ipj) - sx(i))**2/(rj*(rn-rj))
               if (bssij .gt. bssmax) bssmax = bssij
 130        continue
 140     continue
 150     psdiff = max(abs(bpsmax(l)-bpsmin(l-1)), 
     1        abs(bpsmax(l-1)-bpsmin(l)))
         psdiffsq = psdiff**2
         do 170 j = al0,k
            rj = mncwt(j)
            bsslim = psdiffsq/(rj*(rn-rj))
            if (bsslim .lt. bssmax) go to 200
            do 160 i = ilo-j,ilo-1
               ipj = i+j
               rj = cwts(ipj) - cwts(i)
               bssij = (sx(ipj) - sx(i))**2/(rj*(rn-rj))
               if (bssij .gt. bssmax) bssmax = bssij
 160        continue
 170     continue
 200  continue

c      call dblepr("bss max", 7, bssmax, 1)

      if (tss .le. bssmax+0.0001d0) tss = bssmax + 1.0d0
      hwtmaxp = bssmax/((tss-bssmax)/(dble(n)-2.0d0))

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb)

      return
      end

c     the new statistic routine doesn't compute mncwt
      subroutine getmncwt(n, cwts, k, mncwt, delta)
      integer n, k
      double precision cwts(n), mncwt(k), delta

      integer i, j, nmj
      double precision rj, rn

      rn = cwts(n)
      do 30 j = 1,k
         mncwt(j) = cwts(j)
         nmj = n-j
         do 10 i = 1,nmj
            rj = cwts(i+j) - cwts(i)
            mncwt(j) = min(mncwt(j), rj)
 10      continue
         do 20 i = 1, j
            rj = cwts(i+nmj) - cwts(i)
            mncwt(j) = min(mncwt(j), rn-rj)
 20      continue
 30   continue

      j = k+1
      nmj = n-j
      delta = cwts(j)
      do 40 i = 1,nmj
         rj = cwts(i+j) - cwts(i)
         delta = min(delta, rj)
 40   continue
      do 50 i = 1, j
         rj = cwts(i+nmj) - cwts(i)
         delta = min(delta, rn-rj)
 50   continue

      delta = delta/cwts(n)

      return
      end

getbdry <- function(eta, nperm, max.ones, tol= 1e-2) {
  bdry <- rep(0, max.ones*(max.ones+1)/2)
  zz <- .Fortran("getbdry",
                 as.double(eta),
                 as.integer(max.ones),
                 as.integer(nperm),
                 as.integer(max.ones*(max.ones+1)/2),
                 bdry=as.integer(bdry),
                 etastr=double(max.ones),
                 as.double(tol),
                 PACKAGE="DNAcopy")
#  list("eta.star"=zz$etastr, "boundary"=zz$bdry)
  zz$bdry
}

segments.summary <- function(x)
  {
    if (!inherits(x, "DNAcopy")) 
      stop("First arg must be the result of segment")
    xdat <- x$data
    xout <- x$output
    nsample <- ncol(xdat)-2
    sampleid <- colnames(xdat)[-(1:2)]
    seg.median <- seg.sd <- seg.mad <- rep(NA, nrow(xout))
    ll <- 0
    iisamp <- 2
    for (isamp in sampleid) {
      iisamp <- iisamp + 1
# genomdat = logratio data of sample isamp
      genomdat <- xdat[, iisamp]
# ina = location of the missing values and infinity
      ina <- which(is.finite(genomdat))
# subset out the missing & infinity locations
      genomdat <- genomdat[ina]
      seglen <- xout$num.mark[xout$ID == isamp]
      kk <- length(seglen)
      seg.sd[ll+(1:kk)] <- tapply(genomdat, rep(1:kk,seglen), sd)
      seg.median[ll+(1:kk)] <- tapply(genomdat, rep(1:kk,seglen), median)
      seg.mad[ll+(1:kk)] <- tapply(genomdat, rep(1:kk,seglen), mad)
      ll <- ll + kk
    }
    xout$seg.sd <- round(seg.sd, 4)
    xout$seg.median <- round(seg.median, 4)
    xout$seg.mad <- round(seg.mad, 4)
    xout
  }

c     tail probability of circular binary segmentation statistic
c     from Siegmund (1988) or Yao (1989) paper
      double precision function tailp(b, delta, m, ngrid, tol)
      double precision b, delta, tol
      integer m, ngrid
c     it1tsq is the integral of 1/(t*(1-t))**2
      double precision nu, it1tsq
      external nu, it1tsq

      double precision t, tl, dincr, bsqrtm, x, nux
      integer i

      dincr = (0.5d0 - delta)/dble(ngrid)
      bsqrtm = b/sqrt(dble(m))

      tl = 0.5d0 - dincr
      t = 0.5d0 - 0.5d0*dincr
      tailp = 0.0d0
      do 10 i = 1,ngrid
         tl = tl + dincr
         t = t + dincr
         x = bsqrtm/sqrt(t*(1-t))
         nux = nu(x, tol)
         tailp = tailp + (nux**2)*it1tsq(tl, dincr)
 10   continue
      tailp = 9.973557d-2*(b**3)*exp(-b**2/2)*tailp
c     since test is two-sided need to multiply tailp by 2
      tailp = 2.0d0*tailp

      return
      end

c     integral of 1/(t*(1-t))**2 from x to x+a
      double precision function it1tsq(x, a)
      double precision x, a

      double precision y

      y = x + a - 0.5d0
      it1tsq = (8.0d0*y)/(1.0d0 - 4.0d0*y**2) + 
     1     2.0d0*log((1.0d0 + 2.0d0*y)/(1.0d0 - 2.0d0*y))
      y = x - 0.5d0
      it1tsq = it1tsq - (8.0d0*y)/(1.0d0 - 4.0d0*y**2) -
     1     2.0d0*log((1.0d0 + 2.0d0*y)/(1.0d0 - 2.0d0*y))

      return
      end

      double precision function nu(x, tol)
      double precision x, tol

      double precision fpnorm
      external fpnorm

      double precision lnu0, lnu1, dk, xk
      integer i, k

      if (x .gt. 0.01d0) then
         lnu1 = log(2.0d0) - 2*log(x)
         lnu0 = lnu1
         k = 2
         dk = 0
         do 10 i = 1, k
            dk = dk + 1
            xk = -x*sqrt(dk)/2.0d0
            lnu1 = lnu1 - 2.0d0*fpnorm(xk)/dk
 10      continue

         do 50 while (dabs((lnu1-lnu0)/lnu1) .gt. tol)
            lnu0 = lnu1
            do 20 i = 1,k
               dk = dk + 1
               xk = -x*sqrt(dk)/2.0d0
               lnu1 = lnu1 - 2.0d0*fpnorm(xk)/dk
 20         continue
            k = 2*k
 50      enddo
      else
         lnu1 = -0.583d0*x
      endif
      nu = exp(lnu1)

      return
      end

c     tail probability of binary segmentation statistic
c     from page 387 of Siegmund (1986) paper
      double precision function btailp(b, m, ng, tol)
      integer m, ng
      double precision b, tol

      double precision ll, ul, dincr, nulo, nuhi, x, x1, dm
      integer i, k

      double precision fpnorm, nu
      external fpnorm, nu

      dm = dble(m)
      k = 2
      ll = b*sqrt(1.0/dble(m-k) - 1.0/dble(m))
      ul = b*sqrt(1.0/dble(k) - 1.0/dble(m))
      dincr = (ul - ll)/dble(ng)

      btailp = 0.0
      x = ll
      x1 = x + (b**2)/(dm*x)
      nulo = nu(x1, tol)/x
      do 10 i = 1, ng
         x = x + dincr
         x1 = x + (b**2)/(dm*x)
         nuhi = nu(x1, tol)/x
         btailp = btailp + (nuhi + nulo)*dincr
         nulo = nuhi
 10   continue
      btailp = b*exp(-b**2/2)*btailp/2.506628275

      btailp =  btailp + 2*(1.0-fpnorm(b))

      return
      end

c     for binary segmentation of exon data re-use the segment.p code 
c     with one-sided p-value
      subroutine esegp(n, exndat, ostat, eloc, pval, ng, tol)
      integer n, eloc, ng
      double precision exndat(n), ostat, pval, tol

      double precision btailp
      external btailp

      integer i
      double precision tss

      tss = 0
      do 10 i = 1, n
         tss = tss + exndat(i)**2
 10   continue
      call etmax(n, exndat, tss, ostat, eloc)
c      call dblepr("Max Stat",8,ostat,1)
      pval = btailp(ostat, n, ng, tol)
      pval = pval/2
      if (pval .gt. 1) pval = 1.0d0

      return
      end

c     looking for increase in expression - use a one-sided t-statistic
c     t_i = S_i*sqrt(n/(i*(n-i)))/sqrt((tss - S_i^2*n/(i*(n-i)))/(n-2))
      subroutine etmax(n, x, tss, ostat, eloc)
      integer n, eloc
      double precision x(n), tss, ostat

      integer i
      double precision sumxi, btmaxi, dn, di

      sumxi = x(1)
      ostat = 0.0
      eloc = -1
      dn = dble(n)
      di = 1.0
      do 20 i = 2,n-2
         di = di + 1.0
         sumxi = sumxi + x(i)
         btmaxi = -sumxi/sqrt(di*(dn-di))
         if (ostat .lt. btmaxi) then
            ostat = btmaxi
            eloc = i
         endif
 20   continue
      ostat = (ostat/sqrt(tss - dn*ostat**2))*sqrt(dn*(dn-2))

      return
      end

if(dev.cur() <= 1) get(getOption("device"))()

opar <-
    par(ask = interactive() &&
        (.Device %in% c("X11", "GTK", "windows","quartz"))
        )

#datadir <- system.file("examples", package = "DNAcopy")
#Read in two example by Snijders et al.

data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

#We generally recommend smoothing single point outliers before analysis
#Make sure to check that the smoothing is proper

smoothed.CNA.object <- smooth.CNA(CNA.object)

#Segmentation at default parameters

segment.smoothed.CNA.object <- segment(smoothed.CNA.object, verbose=1)

#Plot whole studies

plot(segment.smoothed.CNA.object, plot.type="w")

#Plot each study by chromosome

plot(segment.smoothed.CNA.object, plot.type="s")

#Plot each chromosome across studies (6 per page)

plot(segment.smoothed.CNA.object, plot.type="c", cbys.layout=c(2,1), cbys.nchrom=6)

#Plot by plateaus

plot(segment.smoothed.CNA.object, plot.type="p")

#Segment again but making sure that splits correspond are 3SDs separated

segment.smoothed.CNA.object <- segment(smoothed.CNA.object, undo.splits="sdundo", verbose=1)

#All the non-obvious splits have been removed

plot(segment.smoothed.CNA.object,plot.type="s")

######################################################################
# Type: Redundancy test
# Created by: Henrik Bengtsson <hb@stat.berkeley.edu>
# Created on: 2009-06-10
######################################################################
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Startup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
scriptName <- "benchmark,20090610,segment"

library("DNAcopy")
library("R.utils")

# Record current random seed
sample(1) # Assert that a random seed exists
oldSeed <- .Random.seed
# Alway use the same random seed
set.seed(0xbeef)

# Tolerance (maybe decrease?)
tol <- .Machine$double.eps^0.5

pd <- packageDescription("DNAcopy")
pkgStr <- sprintf("%s v%s", pd$Package, pd$Version) 

figPath <- Arguments$getWritablePath("figures")

benchmarkName <- paste(c(scriptName, gsub(" ", "_", pkgStr)), collapse=",")

logFilename <- sprintf("%s.log", benchmarkName)
log <- Verbose(logFilename, threshold=-10, timestamp=TRUE)

log && header(log, "BENCHMARKING")
log && cat(log, "Script: ", scriptName)
log && print(log, sessionInfo())

benchmarkFilename <- sprintf("%s.Rbin", benchmarkName)
force <- FALSE

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Main benchmarking loop
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Sizes of data sets to be benchmarked
Js <- c(1e3, 1e4, 1e5, 2e5, 5e5, 1e6)


if (!force && isFile(benchmarkFilename)) {
  benchmarkData <- loadObject(benchmarkFilename)
} else {
  benchmarkData <- data.frame(J=NULL, seg=NULL, weightSeg=NULL)
}


for (jj in seq(along=Js)) {
  # Number of loci
  J <- as.integer(Js[jj])

  log && enter(log, sprintf("Case #%d (J=%d) of %d", jj, J, length(Js)))

  if (is.element(J, benchmarkData$J)) {
    log && cat(log, "Already done.")
    log && exit(log)
    next
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Simulating copy-number data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  x <- sort(runif(J, min=0, max=1000))
  w <- runif(J)
  mu <- double(J)
  jj <- (200 <= x & x < 300)
  mu[jj] <- mu[jj] + 1
  jj <- (650 <= x & x < 800)
  mu[jj] <- mu[jj] - 1
  w[jj] <- 0.001
  eps <- rnorm(J, sd=1/2)
  y <- mu + eps

  
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setting up a raw CNA object
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  cnR <- CNA(
    genomdat  = y,
    chrom     = rep(1, times=J),
    maploc    = x,
    data.type = "logratio",
    sampleid  = "SampleA"
  )
  log && print(log, cnR)
  
  
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Non-weighted segmentation
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  log && enter(log, "Non-weighted segmentation")
  t1 <- system.time({
  fitR <- segment(cnR, verbose=1)
  })[3]
  log && printf(log, "Processing time: %.3f secs\n", t1)
  log && print(log, fitR)
  log && exit(log)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Weighted segmentation
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  log && enter(log, "Weighted segmentation")
  t2 <- system.time({
  fitR <- segment(cnR, weights=w, verbose=1)
  })[3]
  log && printf(log, "Processing time: %.3f secs\n", t1)
  log && print(log, fitR)
  log && exit(log)
  

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Record benchmarking
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  timings <- data.frame(J=J, seg=t1, weightSeg=t2)
  benchmarkData <- rbind(benchmarkData, timings)
  log && print(log, benchmarkData)

  # Saving to file  
  saveObject(benchmarkData, file=benchmarkFilename)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Cleanup
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Reset to previous random seed
  .Random.seed <- oldSeed

  log && exit(log)
} # for (jj ...)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Benchmarking summary
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
log && print(log, benchmarkData)

log && header(log, "APPENDIX")
log && print(log, sessionInfo())


figName <- paste(c(scriptName, gsub(" ", "_", pkgStr)), collapse=",")
width <- 640
height <- 0.618*width
filename <- sprintf("%s.png", figName)
pathname <- file.path(figPath, filename)
devNew(png, pathname, width=width, height=height)
n <- ncol(benchmarkData)-1
matplot(benchmarkData[1], benchmarkData[,-1], type="b", pch=20, lwd=3, 
                               xlab="J", ylab="seconds", main=pkgStr)
legend("topleft", colnames(benchmarkData)[-1], col=1:n, lty=1:n, lwd=3)
devDone()


######################################################################
# HISTORY:
# 2009-06-10
# o Benchmarking show a major improvement in the algorithm when going
#   from DNAcopy v1.19.0 to the recent DNAcopy v1.19.2.  It was 
#   roughly O(J*ln(J)) and now it is O(J).  For a chromosome with
#   500,000 loci, we observed a speed up in the weighted case going
#   from 20 mins to 30 seconds, which is a 40 times speedup.
# o Created.
######################################################################

c     n = length(gdat) i.e. number of markers and log-ratio
c     k is the neighborhood width
c     oSD = how far the outlier is to the nearest observation
c     sSD = how close should it be moved
c     nchr = number of chromosomes
c     cfrq = number of probes in respective chromosomes
      subroutine smoothLR(n, gdat, nchr, cfrq, sgdat, k, oSD, sSD)
      integer n, nchr, cfrq(nchr), k
      double precision gdat(n), sgdat(n), oSD, sSD

      integer i, j, ilo, ihi, k1, k2, j1, ic, cilo, cihi
      double precision mnnbd, mxnbd, distij, xmed

c     temporary array for finding median
      double precision, allocatable :: xnbhd(:)

      k2 = 2*k + 1
      allocate(xnbhd(k2))

c     initial values for start and end of chromosomes
      cilo = 1
      cihi = 0
c     loop over chromomsomes
      do 100 ic = 1, nchr
c     end of the current chromosome
         cihi = cihi + cfrq(ic)
         do 50 i = cilo, cihi
c     range of the neighborhood
            ilo = max(cilo, i-k)
            ihi = min(cihi, i+k)
c     check if ith observation is an outlier
c     initialize the distances to be large
            mxnbd = 100*oSD
            mnnbd = 100*oSD
            do 10 j = ilo, ihi
               if (j .ne. i) then
c     calculate distance from between ith and jth obsn
                  distij = gdat(i) - gdat(j)
c     if distance is less than oSD no smoothing necessary
                  if (abs(distij) .le. oSD) then
                     sgdat(i) = gdat(i)
                     go to 50
c     otherwise calculate distances from above and below
                  else
c     mxnbd is distance from above
                     if (distij .lt. mxnbd) mxnbd = distij
c     mnnbd is distance from below
                     if (-distij .lt. mnnbd) mnnbd = -distij
                  endif
               endif
 10         continue
c     if all the points in the nbhd are above than mxnbd will be negative
c     and mnnbd will be greater than oSD. Vice versa if all points below
c     
c     If both are negative then the ith point is singleton in the middle 
c     but distance oSD away from all points in the nbhd. No smoothing done.
            if ((mxnbd .le. 0) .and. (mnnbd .le. 0)) then
               sgdat(i) = gdat(i)
               go to 50
            else
c     calculate the median of the nbhd
c     number of points in the nbhd
               k1 = ihi - ilo + 1
c     get the data into temporary array
               do 20 j = ilo, ihi
                  xnbhd(j-ilo+1) = gdat(j)
 20            continue
c     sort the data
               call qsort3(xnbhd, 1, k1)
c     median is the midpoint if n is odd and average of the two if even
               j1 = k1/2
               if (k1 .eq. 2*j1) then
                  xmed = (xnbhd(j1) + xnbhd(j1+1))/2
               else
                  xmed = xnbhd(j1+1)
               endif
c     if point is above the nbhd bring it down
               if (mxnbd .gt. 0) sgdat(i) = xmed + sSD
c     if point is below the nbhd bring it up
               if (mnnbd .gt. 0) sgdat(i) = xmed - sSD
            endif
 50      continue
c     beginning of next chromosome
         cilo = cilo + cfrq(ic)
 100  continue
      deallocate(xnbhd)

      return
      end

      subroutine getbdry(eta, m, nperm, mb, ibdry, etastr, tol)
      integer m, nperm, mb, ibdry(mb)
      double precision eta, etastr(m), tol

      double precision eta0, etalo, etahi, plo, phi, pexcd
      integer j, l

      l = 1
      ibdry(1) = nperm-int(dble(nperm)*eta)
      etastr(1) = eta
      eta0 = eta
      do 20 j = 2,m
         etahi = eta0*1.1
         call etabdry(nperm, etahi, j, ibdry(l+1))
         call pexceed(nperm, j, ibdry(l+1), phi)
         etalo = eta0*0.25
         call etabdry(nperm, etalo, j, ibdry(l+1))
         call pexceed(nperm, j, ibdry(l+1), plo)
         do 10 while ((etahi-etalo)/etalo .gt. tol)
            eta0 = etalo + (etahi-etalo)*(eta-plo)/(phi-plo)
            call etabdry(nperm, eta0, j, ibdry(l+1))
            call pexceed(nperm, j, ibdry(l+1), pexcd)
            if (pexcd .gt. eta) then
               etahi = eta0
               phi = pexcd
            else
               etalo = eta0
               plo = pexcd
            endif
 10      continue
         etastr(j) = eta0
         l = l+j
 20   continue

      return
      end

      subroutine etabdry(nperm, eta0, n1s, ibdry)
      integer nperm, n1s, ibdry(n1s)
      double precision eta0

      double precision fphypr
      external fphypr

      integer i, k
      double precision di, dn, dn1s, dk, tprob

      dn1s = dble(n1s)
      dn = dble(nperm-n1s)
      
      k = 0
      dk = 0.0d0
      do 10 i = 1, nperm
         di = dble(i)
         tprob = fphypr(dk, dn1s, dn, di)
         if (tprob .le. eta0) then
            k = k+1
            dk = dk + 1.0d0
            ibdry(k) = i
         endif
 10   continue

      return
      end

      subroutine pexceed(nperm, n1s, ibdry, pexcd)
      integer nperm, n1s, ibdry(n1s)
      double precision pexcd

      double precision dn, dk, dn1, dk1, dn2, dk2, dn3, dk3, dlcnk
      integer i

      double precision flchoose
      external flchoose

      dn = dble(nperm)
      dk = dble(n1s)
      dn1 = dble(nperm-ibdry(1))
      dlcnk = flchoose(dn, dk)

      pexcd = exp(flchoose(dn1, dk) - dlcnk)

      if (n1s .ge. 2) then
         dn1 = dble(ibdry(1))
         dn = dble(nperm-ibdry(2))
         dk = dble(n1s-1)
         pexcd = pexcd + exp(log(dn1) + flchoose(dn, dk) - dlcnk)
      endif

      if (n1s .ge. 3) then
         dn1 = dble(ibdry(1))
         dn2 = dble(ibdry(2))
         dn = dble(nperm-ibdry(3))
         dk = dble(n1s-2)
         pexcd = pexcd + 
     1        exp(log(dn1) + log(dn1-1.0) - log(2.0) + 
     2                        flchoose(dn, dk) - dlcnk) +
     3        exp(log(dn1) + log(dn2-dn1) + flchoose(dn, dk) - dlcnk)
      endif

      if (n1s .gt. 3) then
         do 10 i = 4, n1s
            dn1 = dble(ibdry(i-3))
            dk1 = dble(i-1)
            dk2 = dble(i-2)
            dk3 = dble(i-3)
            dn2 = dble(ibdry(i-2))
            dn3 = dble(ibdry(i-1))
            dn = dble(nperm-ibdry(i))
            dk = dble(n1s-i+1)
            pexcd = pexcd + 
     1           exp(flchoose(dn1, dk1) + flchoose(dn, dk) - dlcnk) +
     2           exp(flchoose(dn1, dk2) + log(dn3-dn1) + 
     3                       flchoose(dn, dk) - dlcnk) +
     4           exp(flchoose(dn1, dk3) + log(dn2-dn1) + log(dn3-dn2) +
     3                        flchoose(dn, dk) - dlcnk) +
     5           exp(flchoose(dn1, dk3) + log(dn2-dn1) - log(2.0) + 
     6                    log(dn2-dn1-1.0) + flchoose(dn, dk) - dlcnk)
 10      continue
      endif

      return
      end

CNA <- function(genomdat, chrom, maploc, data.type=c("logratio","binary"),
                   sampleid=NULL, presorted=FALSE)
  {
    if (is.data.frame(genomdat)) genomdat <- as.matrix(genomdat)
    if (!is.numeric(genomdat)) stop("genomdat must be numeric")
    if (!is.numeric(maploc)) stop("maploc must be numeric")
    data.type <- match.arg(data.type)
    ina <- (!is.na(chrom) & is.finite(maploc))
    if (sum(!ina)>0)
      warning("markers with missing chrom and/or maploc removed\n")
    if (!presorted) {
      sortindex <- which(ina)[order(chrom[ina], maploc[ina])]
    } else {
      sortindex <- which(ina)
    }
    if (is.factor(chrom)) chrom <- as.character(chrom)
    # added to allow arrays of single dimension - results from data.frame ops
    if (is.array(genomdat)) {
        if (length(dim(genomdat)) == 1) {
            genomdat <- as.matrix(genomdat)
        }
    }
    if (is.vector(genomdat)) genomdat <- as.matrix(genomdat)
    if (!missing(sampleid)) {
      if (length(sampleid) != ncol(genomdat)) {
        warning("length(sampleid) and ncol(genomdat) differ, names ignored\n")
        sampleid <- paste("Sample", 1:ncol(genomdat))
      } 
    } else {
        sampleid <- paste("Sample", 1:ncol(genomdat))
    }
    colnames(genomdat) <- sampleid
    zzz <- data.frame(chrom=I(chrom), maploc=maploc, genomdat)
    zzz <- zzz[sortindex,]

# check for duplicate probes (i.e. repeated maploc within a chromosome)
    if (length(ii <- which(diff(maploc)==0)) > 0) {
      if (any(chrom[ii]==chrom[ii+1])) warning("array has repeated maploc positions\n")
    }

    attr(zzz, "data.type") <- data.type
    class(zzz) <- c("CNA","data.frame")
    zzz
  }

subset.CNA <- function(x, chromlist=NULL, samplelist=NULL, ...)
  {
    if (!inherits(x, 'CNA')) stop("First arg must be of class CNA")
    chrom <- x$chrom
    uchrom <- unique(chrom)
    if (missing(chromlist)) chromlist <- uchrom
    if (length(setdiff(chromlist, uchrom)) > 0)
      stop("chromlist contains chromosomes not in the data")
    if (length(chromlist) > length(unique(chromlist)))
      warning("duplicate chromosomes in chromlist removed")
    sampleid <- colnames(x)[-(1:2)]
    if (missing(samplelist)) samplelist <- sampleid
    nsample <- length(sampleid)
    if (length(setdiff(samplelist, 1:nsample)) > 0 & length(setdiff(samplelist, sampleid)) > 0)
      stop("samplelist should be a list of valid sample numbers or names")
    if (!is.numeric(samplelist)) samplelist <- match(samplelist, names(x)) - 2
    if (length(samplelist) > length(unique(samplelist)))
      warning("duplicate samples in samplelist removed")
    samplelist <- unique(samplelist)
    y <- x[chrom %in% chromlist,c(1:2,samplelist+2)]
    attr(y, "data.type") <- attr(x, "data.type")
    y
  }

smooth.CNA <- function(x, smooth.region=10, outlier.SD.scale=4,
                       smooth.SD.scale=2, trim=0.025)
  {
    if (!inherits(x, 'CNA')) stop("First arg must be of class CNA")
    nsample <- ncol(x)-2
    chrom <- x$chrom
    uchrom <- unique(chrom)
    if(attr(x, "data.type")=="binary") stop("Not smoothing binary data ")
    for (isamp in 1:nsample) {
      genomdat <- x[,isamp+2]
      ina <- which(is.finite(genomdat))
      trimmed.SD <- sqrt(trimmed.variance(genomdat[ina], trim))
      outlier.SD <- outlier.SD.scale*trimmed.SD
      smooth.SD <- smooth.SD.scale*trimmed.SD
      k <- smooth.region
      n <- length(genomdat[ina])
      cfrq <- diff(c(which(!duplicated(chrom[ina])), n+1))
      nchr <- length(cfrq) # to allow for some chrom with all missing
      smoothed.data <- .Fortran("smoothLR",
                                as.integer(n),
                                as.double(genomdat[ina]),
                                as.integer(nchr),
                                as.integer(cfrq),
                                sgdat=double(n),
                                as.integer(k),
                                as.double(outlier.SD),
                                as.double(smooth.SD),
                                PACKAGE = "DNAcopy")$sgdat
      x[,isamp+2][ina] <- smoothed.data
    }
    x
  }

print.CNA <- function(x, ...)
  {
    if (!inherits(x, 'CNA')) stop("First arg must be of class CNA")
    cat("Number of Samples", ncol(x)-2,
        "\nNumber of Probes ", nrow(x),
        "\nData Type        ", attr(x,"data.type"),"\n")
  }

plot.DNAcopy <- function (x, plot.type=c("whole", "plateau", "samplebychrom",
                               "chrombysample"), xmaploc=FALSE, altcol=TRUE,
                          sbyc.layout=NULL, cbys.nchrom=1, cbys.layout=NULL,
                          include.means=TRUE, zeroline=TRUE, pt.pch=NULL,
                          pt.cex=NULL, pt.cols=NULL, segcol=NULL, zlcol=NULL,
                          ylim=NULL, lwd=NULL, ...)
{
  if (!inherits(x, "DNAcopy")) 
    stop("First arg must be the result of segment")
  xdat <- x$data
  nsample <- ncol(xdat)-2
  if(missing(ylim)) {
    uylim <- max(abs(xdat[,-(1:2)]), na.rm=TRUE)
    ylim <- c(-uylim, uylim)
  }
  xres <- x$output
  if(dev.cur() <= 1) dev.new()
  int.dev <- dev.interactive()
  plot.type <- match.arg(plot.type)
  op <- par(no.readonly = TRUE)
  parask <- par("ask")
  if (int.dev & !parask & nsample>1) par(ask = TRUE)
  sampleid <- colnames(xdat)[-(1:2)]
  chrom0 <- xdat$chrom
  uchrom <- unique(chrom0)
  nchrom <- length(uchrom)
  if (xmaploc) {
    maploc0 <- as.numeric(xdat$maploc)
    if(length(uchrom)>1 & max(maploc0[chrom0==uchrom[1]]) > min(maploc0[chrom0==uchrom[2]])) {
      plen <- max(maploc0[chrom0==uchrom[1]])
      for(i in 2:nchrom) {
        maploc0[chrom0==uchrom[i]] <- plen + maploc0[chrom0==uchrom[i]]
        plen <- max(maploc0[chrom0==uchrom[i]])
      }
    }
  }
  if (missing(pt.pch)) pt.pch <- "."
  if (missing(pt.cex)) {
    if (pt.pch==".") { pt.cex <- 3}
    else {pt.cex <- 1}
  }
  wcol0 <- rep(1, length(chrom0))
  if (altcol) {
    j <- 0
    for (i in uchrom) {
      j <- (j+1) %% 2
      wcol0[chrom0==i] <- 1+j
    }
  }
  if (missing(pt.cols)) pt.cols <- c("black","green")
  if (missing(segcol)) segcol <- "red"
  if (missing(zlcol)) zlcol <- "grey"
  if (missing(lwd)) lwd <- 3
  if (plot.type == "chrombysample") {
    cat("Setting multi-figure configuration\n")
    par(mar = c(0, 4, 0, 2), oma = c(4, 0, 4, 0), mgp = c(2, 0.7, 0))
    if (missing(cbys.layout)) {
      nrow <- ncol <- ceiling(sqrt(nsample))
      if (nrow*ncol - nsample > 0) {
        nrow <- nrow - 1
        ncol <- ncol + 1
      }
      if (nrow*ncol - nsample >= nrow) ncol <- ncol - 1
      cbys.layout <- c(nrow, ncol)
    }
    lmat0 <- lmat1 <- c(1:nsample, rep(-cbys.nchrom*nsample, prod(cbys.layout) - nsample))
    for(i in 1:(cbys.nchrom-1)) {
      lmat1 <- c(lmat1,lmat0+nsample*i)
    }
    lmat1[lmat1<0] <- 0
    lmat <- matrix(lmat1, nrow = cbys.layout[1], ncol = cbys.nchrom*cbys.layout[2], byrow = FALSE)
    layout(lmat)
  }
  if (plot.type == "samplebychrom") {
    cat("Setting multi-figure configuration\n")
    par(mar = c(4, 4, 4, 2), oma = c(0, 0, 2, 0), mgp = c(2, 0.7, 0))
    if (missing(sbyc.layout)) {
      nrow <- ncol <- ceiling(sqrt(nchrom))
      if (nrow*ncol - nchrom > 0) {
        nrow <- nrow - 1
        ncol <- ncol + 1
      }
      if (nrow*ncol - nchrom > ncol) ncol <- ncol - 1
      sbyc.layout <- c(nrow, ncol)
    }
    lmat <- matrix(c(1:nchrom, rep(0,prod(sbyc.layout)-nchrom)),
                   nrow = sbyc.layout[1], ncol = sbyc.layout[2], byrow=TRUE)
    layout(lmat)
  }
  if (plot.type == "chrombysample") {
    atchrom <- 0.5/cbys.nchrom
    for (ichrom in uchrom) {
      if (xmaploc) maploc1 <- maploc0[chrom0==ichrom]
      for (isamp in 1:nsample) {
        genomdat <- xdat[chrom0==ichrom, isamp+2]
        ina <- which(is.finite(genomdat))
        genomdat <- genomdat[ina]
        if (xmaploc) maploc <- maploc1[ina]
        ii <- cumsum(c(0, xres$num.mark[xres$ID == sampleid[isamp] & xres$chrom==ichrom]))
        mm <- xres$seg.mean[xres$ID == sampleid[isamp] & xres$chrom==ichrom]
        kk <- length(ii)
        zz <- cbind(ii[-kk] + 1, ii[-1])
        if (xmaploc) {
          plot(maploc, genomdat, pch = pt.pch, cex=pt.cex, xaxt="n", ylim = ylim, ylab = sampleid[isamp])
        } else {
          plot(genomdat, pch = pt.pch, cex=pt.cex, xaxt="n", ylim = ylim, ylab = sampleid[isamp])
        }
        if(zeroline) abline(h=0, col=zlcol, lwd=lwd)
        if (isamp%%cbys.layout[1] == 0) {
          axis(1, outer=TRUE)
          title(xlab="Index")
        }
        if (include.means) {
          if (xmaploc) {
            segments(maploc[zz[,1]], mm, x1=maploc[zz[,2]], y1=mm, col = segcol, lwd=lwd)
          } else {
            segments(zz[,1], mm, x1=zz[,2], y1=mm, col = segcol, lwd=lwd)
          }
#          for (i in 1:(kk - 1)) {
#            if (xmaploc) { 
#              lines(maploc[zz[i, ]], rep(mm[i], 2), col = segcol, lwd=lwd)
#            } else {
#              lines(zz[i, ], rep(mm[i], 2), col = segcol, lwd=lwd)
#            }
#          }
        }
      }
      mtext(paste("Chromosome",ichrom), side = 3, line = 1, at = atchrom, outer=TRUE, font=2)
      atchrom <- atchrom + 1/cbys.nchrom
      atchrom <- atchrom - floor(atchrom)
    }
  } else {
    for (isamp in 1:nsample)
      {
        genomdat <- xdat[, isamp+2]
        ina <- which(is.finite(genomdat))
        genomdat <- genomdat[ina]
        wcol <- wcol0[ina]
        chrom <- chrom0[ina]
        if (xmaploc) maploc <- maploc0[ina]
        ii <- cumsum(c(0, xres$num.mark[xres$ID == sampleid[isamp]]))
        mm <- xres$seg.mean[xres$ID == sampleid[isamp]]
        kk <- length(ii)
        zz <- cbind(ii[-kk] + 1, ii[-1])
        if(missing(ylim)) ylim <- range(c(genomdat, -genomdat))
        if (plot.type=="whole")
          {
            if (xmaploc) {
              plot(maploc, genomdat, pch = pt.pch, cex=pt.cex, col=pt.cols[wcol], main = sampleid[isamp], ylab = "", ylim = ylim)
              if(zeroline) abline(h=0, col=zlcol, lwd=lwd)
            } else {
              plot(genomdat, pch = pt.pch, cex=pt.cex, col=pt.cols[wcol], main = sampleid[isamp], ylab = "", ylim = ylim)
              if(zeroline) abline(h=0, col=zlcol, lwd=lwd)
            }
            if (include.means) {
              if (xmaploc) {
                segments(maploc[zz[,1]], mm, x1=maploc[zz[,2]], y1=mm, col = segcol, lwd=lwd)
              } else {
                segments(zz[,1], mm, x1=zz[,2], y1=mm, col = segcol, lwd=lwd)
              }
#              for (i in 1:(kk - 1))
#                {
#                  if (xmaploc) { 
#                    lines(maploc[zz[i, ]], rep(mm[i], 2), col = segcol, lwd=lwd)
#                  } else {
#                    lines(zz[i, ], rep(mm[i], 2), col = segcol, lwd=lwd)
#                  }
#                }
            }
          }
        if (plot.type=="samplebychrom")
          {
            cc <- xres$chrom[xres$ID == sampleid[isamp]]
            for (ichrom in uchrom)
              {
                if (xmaploc) {
                  plot(maploc[chrom == ichrom], genomdat[chrom == ichrom], pch = pt.pch, cex=pt.cex, xlab="maploc", ylab = "", main = paste("Chromosome", ichrom), ylim = ylim)
                } else {
                  plot(genomdat[chrom == ichrom], pch = pt.pch, cex=pt.cex, ylab = "", main = paste("Chromosome", ichrom), ylim = ylim)
                }
                if(zeroline) abline(h=0, col=zlcol, lwd=lwd)
                if (include.means) {
                  jj <- which(cc==ichrom)
                  jj0 <- min(jj)
                  if (xmaploc) {
                    segments(maploc[zz[jj,1]], mm[jj], x1=maploc[zz[jj,2]], y1=mm[jj], col = segcol, lwd=lwd)
                  } else {
                    segments(1+zz[jj,1]-zz[jj0,1], mm[jj], x1=1+zz[jj,2]-zz[jj0,1], y1=mm[jj], col = segcol, lwd=lwd)
                  }
#                  for (i in jj)
#                    {
#                      if (xmaploc) {
#                        lines(maploc[zz[i, ]], rep(mm[i], 2), col = segcol, lwd=lwd)
#                      } else {
#                        lines(1+zz[i, ]-zz[jj0,1], rep(mm[i], 2), col = segcol, lwd=lwd)
#                      }
#                    }
                }
              }
            mtext(sampleid[isamp], side = 3, line = 0, outer = TRUE, font=2)
          }
        if (plot.type=="plateau")
          {
            omm <- order(mm)
            ozz <- zz[omm,]
            ina <- unlist(apply(ozz, 1, function(ii) ii[1]:ii[2]))
            plot(genomdat[ina], pch = pt.pch, cex=pt.cex, main = sampleid[isamp], ylab = "", ylim = ylim)
            if(zeroline) abline(h=0, col=zlcol, lwd=lwd)
            if (include.means) {
              ii <- cumsum(c(0, xres$num.mark[xres$ID == sampleid[isamp]][omm]))
              smm <- mm[omm]
              zz <- cbind(ii[-kk] + 1, ii[-1])
              segments(zz[,1], smm, x1=zz[,2], y1=smm, col = segcol, lwd=lwd)
#              for (i in 1:(kk-1)) lines(zz[i, ], rep(smm[i], 2), col = segcol, lwd=lwd)
            }
          }
      }
  }
  on.exit( if (plot.type=="chrombysample" | plot.type=="samplebychrom") {
    par(op)
  } else { if(int.dev & !parask & nsample>1) par(ask=parask) })
}

print.DNAcopy <- function(x, showSegRows=FALSE, ...)
  {
    if (!inherits(x, "DNAcopy")) stop("Object is not the result of segment")
    if (!is.null(cl<- x$call))
      {
        cat("Call:\n")
        dput(cl)
        cat("\n")
      }
    if (showSegRows) {
      if (is.null(x$segRows)) {
        print(x$output)
        warning("segRows missing.  Object may be a subset or from DNAcopy < 1.23.2.\n")
      } else {
        print(cbind(x$output, x$segRows))
      }
    } else {
      print(x$output)
    }
  }

subset.DNAcopy <- function(x, chromlist=NULL, samplelist=NULL, ...)
  {
    if (!inherits(x, 'DNAcopy')) stop("First arg must be of class DNAcopy")
    zdat <- x$data
    zres <- x$output
    chrom <- zdat$chrom
    uchrom <- unique(chrom)
    if (missing(chromlist) | is.null(chromlist)) chromlist <- uchrom
    if (length(setdiff(chromlist, uchrom)) > 0)
      stop("chromlist contains chromosomes not in the data")
    if (length(chromlist) > length(unique(chromlist)))
      warning("duplicate chromosomes in chromlist removed")
    sampleid <- colnames(zdat)[-(1:2)]
    if (missing(samplelist)) samplelist <- sampleid
    nsample <- length(sampleid)
    if (length(setdiff(samplelist, 1:nsample)) > 0 & length(setdiff(samplelist, sampleid)) > 0)
      stop("samplelist should be a list of valid sample numbers or names")
    if (!is.numeric(samplelist)) samplelist <- match(samplelist, names(zdat)) - 2
    if (length(samplelist) > length(unique(samplelist)))
      warning("duplicate samples in samplelist removed")
    samplelist <- unique(samplelist)
    jj <- unlist(sapply(sampleid[samplelist], function(i, id) {which(id==i)}, zres$ID ))
    zres <- zres[jj,]
    y <- list()
    y$data <- zdat[chrom %in% chromlist,c(1:2,samplelist+2)]
    attr(y$data, "data.type") <- attr(zdat, "data.type")
    y$output <- zres[zres$chrom %in% chromlist,]
    class(y) <- "DNAcopy"
    y
  }

# Chromosome.Lengths <- c(263, 255, 214, 203, 194, 183, 171, 155, 145, 144, 144, 143, 114, 109, 106, 98, 92, 85, 67, 72, 50, 56, 164, 59)
# names(Chromosome.Lengths) <- c(as.character(1:22),"X","Y")

      subroutine bsegp(n, gendat, ostat, pval, ng, tol)
      integer n, ng
      double precision gendat(n), ostat, pval, tol

      double precision btmax, btailp
      external btmax, btailp

      ostat = btmax(n, gendat)
c      call dblepr("Max Stat",8,ostat,1)
      pval = btailp(ostat, n, ng, tol)
      if (pval .gt. 1) pval = 1.0d0

      return
      end

      double precision function btmax(n, x)
      integer n
      double precision x(n)

      integer i
      double precision sumxi, btmaxi, dn, di, ostat

      sumxi = x(1)
      ostat = 0.0
      dn = dble(n)
      di = 1.0
      do 20 i = 2,n-2
         di = di + 1.0
         sumxi = sumxi + x(i)
         btmaxi = dn*(sumxi**2)/(di*(dn-di))
         if (ostat .lt. btmaxi) then
            ostat = btmaxi
c            ibseg = i
         endif
 20   continue
      btmax = sqrt(ostat)

      return
      end

c     pseudo confidence interval based on permutations
      subroutine bsegci(n, k, sumxk, x, px, sr, vfact, nperm, bsloc)
      integer n, k, sr(2), nperm, bsloc(nperm)
      double precision sumxk, x(n), px(n), vfact(n)

      integer k1, nk, np, ibseg

      call rndstart()
      k1 = k+1
      nk = n-k
      do 10 np = 1, nperm
         call xperm(k,x,px)
         call xperm(nk,x(k1),px(k1))
         call btmxci(n,k,sr,px,vfact,ibseg,sumxk)
         bsloc(np) = ibseg
 10   continue
      call rndend()

      return
      end

      subroutine btmxci(n,k,sr,x,vfact,ibseg,sumxk)
      integer n,k,sr(2),ibseg
      double precision x(n),vfact(n),sumxk

      integer i
      double precision sumxi, ostat, btmaxi

      ostat = vfact(k)*(sumxk**2)
      ibseg = k
      sumxi = sumxk
      do 10 i = k-1,sr(1),-1
         sumxi = sumxi - x(i+1)
         btmaxi = vfact(i)*(sumxi**2)
         if (ostat .lt. btmaxi) then
            ostat = btmaxi
            ibseg = i
         endif
 10   continue

      sumxi = sumxk
      do 20 i = k+1,sr(2)
         sumxi = sumxi + x(i)
         btmaxi = vfact(i)*(sumxi**2)
         if (ostat .lt. btmaxi) then
            ostat = btmaxi
            ibseg = i
         endif
 20   continue
      ostat = sqrt(ostat)

      return
      end

exon.segment <- function(gene, eloc, edat, ngrid=100, tol=1e-6) {
  ii <- order(gene, eloc)
  gene <- gene[ii]
  eloc <- eloc[ii]
  if (is.matrix(edat)) {
    edat <- edat[ii,]
  } else {
    edat <- cbind(edat[ii])
  }
  ugene <- unique(gene)
  ngene <- length(ugene)
  nsample <- ncol(edat)
  out.stat <- out.loc <- out.p <- matrix(0, ngene, nsample)
  ss <- 3*(1:nsample)
  for(i in 1:ngene) {
    exondat <- edat[gene==ugene[i],]
    gout <- exon.changepoint(exondat, ngrid, tol)
    out.stat[i,] <- gout[[1]]
    out.loc[i,] <- gout[[2]]
    out.p[i,] <- gout[[3]]
  }
  rownames(out.stat) <- rownames(out.loc) <- rownames(out.p) <- ugene
  list(statistic=out.stat, location=out.loc, p.value=out.p)
}

exon.changepoint <- function(exondat, ngrid=100, tol=1e-6) {
# 
# exondat -- is a matrix of normalized expression values
#   rows are ordered by location and columns are samples
#
  nsample <- ncol(exondat) # number of samples
  n <- nrow(exondat) # number of exons in the gene
# initialize sample specific output
  estat <- epval <- eloc <- rep(0, nsample)
# calculate the max t-stat, location and p-value
  for(i in 1:nsample) {
    exondati <- exondat[,i]
#   center the data
    exondati <- (exondati - mean(exondati))
# call the p-value subroutine
    zzz <- .Fortran("esegp",
                    as.integer(n),
                    as.double(exondati),
                    ostat=double(1),
                    eloc=integer(1),
                    pval=double(1),
                    as.integer(ngrid),
                    as.double(tol),
                    PACKAGE="DNAcopy")
    estat[i] <- zzz$ostat
    epval[i] <- zzz$pval
    eloc[i] <- zzz$eloc
  }
  list(estat, eloc, epval)
}

segments.p <- function(x, ngrid=100, tol=1e-6, alpha=0.05, search.range=100,
                       nperm=1000)
  {
    if (!inherits(x, "DNAcopy")) 
      stop("First arg must be the result of segment")
    xdat <- x$data
    xout <- x$output
    nsample <- ncol(xdat)-2
    sampleid <- colnames(xdat)[-(1:2)]
    chrom0 <- xdat$chrom
    maploc0 <- xdat$maploc
    uchrom <- unique(chrom0)
    nchrom <- length(uchrom)
    bstat <- pval <- lcl <- ucl <- rep(NA, nrow(xout))
    ll <- 0
    iisamp <- 2
    for (isamp in sampleid) {
      iisamp <- iisamp + 1
# genomdat = logratio data of sample isamp
      genomdat <- xdat[, iisamp]
# ina = location of the missing values and infinity
      ina <- which(is.finite(genomdat))
# subset out the missing & infinity locations
      genomdat <- genomdat[ina]
      chrom <- chrom0[ina]
      maploc <- maploc0[ina]
      for(ichrom in uchrom) {
# kk = number of segments in chromosome ichrom of sample isamp
        kk <- sum(1*(xout$ID == isamp & xout$chrom == ichrom))
        if (kk > 1) {
# gendat = logratio data in chromosome ichrom of sample isamp
          gendat <- genomdat[chrom == ichrom]
# seglen = lengths of the segments in chromosome ichrom of sample isamp
          seglen <- xout$num.mark[xout$ID == isamp & xout$chrom == ichrom]
# segmean = means of the segments in chromosome ichrom of sample isamp
          segmean <- xout$seg.mean[xout$ID == isamp & xout$chrom == ichrom]
# xresid = residuals of the data in chromosome ichrom of sample isamp
          xresid <- gendat - rep(segmean, seglen)
          ibstat <- ipval <- ilcl <- iucl <- rep(NA, kk)
# begin with the first 2 segments lo & hi are the start & end points
          lo <- 1
          hi <- sum(seglen[1:2])
          for(i in 1:(kk-1)) {
# prep data from adjacent segments
            gendati <- gendat[lo:hi]
            xresidi <- xresid[lo:hi]
# standardize data
            gendati <- (gendati - mean(gendati))/sd(xresidi)
            n <- length(gendati)
# call the p-value subroutine
            zzz <- .Fortran("bsegp",
                            as.integer(n),
                            as.double(gendati),
                            ostat=double(1),
                            pval=double(1),
                            as.integer(ngrid),
                            as.double(tol),
                            PACKAGE="DNAcopy")
            ibstat[i] <- zzz$ostat
            ipval[i] <- zzz$pval
# additional data for CI routine 
# k = location of change-point
# sr = search range
# sumxk = partial sum at k (all paths are pegged at that point)
# var.factor = variance for 2-sample t-statistic
            k <- seglen[i]
            sr <- c(max(2, k-search.range),min(n-2,k+search.range))
            sumxk <- sum(gendati[1:k])
            var.factor <- n/((1:n)*(n:1 - 1))
            var.factor[n] <- 0
# call the confidence subroutine
            zzz <- .Fortran("bsegci",
                            as.integer(n),
                            as.integer(k),
                            as.double(sumxk),
                            as.double(gendati),
                            px = double(n),
                            sr = as.integer(sr),
                            vfact = as.double(var.factor),
                            as.integer(nperm),
                            bsloc = integer(nperm),
                            PACKAGE="DNAcopy")
            bsloc <- zzz$bsloc
            bsci <- quantile(bsloc, c(alpha/2, 1-alpha/2), type=1)
            ilcl[i] <- bsci[1]
            iucl[i] <- bsci[2]
# increment to the next segment
            lo <- lo + seglen[i]
            if(i < kk-1) hi <- hi + seglen[i+2]
          }
          ibstat[kk] <- ipval[kk] <- ilcl[kk] <- iucl[kk] <- NA
        } else {
          seglen <- ibstat <- ipval <- ilcl <- iucl <- NA
        }
        bstat[ll + (1:kk)] <- ibstat
        pval[ll + (1:kk)] <- ipval
# convert the lcl & ucl from probe number to maploc
        lcl[ll + (1:kk)] <- maploc[chrom == ichrom][cumsum(seglen) + (ilcl - seglen)]
        ucl[ll + (1:kk)] <- maploc[chrom == ichrom][cumsum(seglen) + (iucl - seglen)]
        ll <- ll + kk
      }
    }
    cbind(xout, bstat, pval, lcl, ucl)
  }

glFrequency <- function(xout, threshold=1) {
  if (!inherits(xout, 'DNAcopy')) stop("First arg must be of class DNAcopy")
  nsample <- ncol(xout$data)-2
  snames <- names(xout$data)
  xmad <- rep(NA,nsample)
  for(i in 2+(1:nsample)) {
    sout <- xout$output[xout$output$ID==snames[i],]
    xmad[i-2] <- mad(na.omit(xout$data[,i]) - rep(sout$seg.mean,sout$num.mark))
  }
  pfreq <- gain <- loss <- rep(0, nrow(xout$data))
  for(i in 1:nsample) {
#    ii <- !is.na(xout$data[,i+2])
    genomdat <- xout$data[,i+2]
# ii = location of the missing values and infinity
    ii <- which(is.finite(genomdat))
# segment means as a vector
    segout <- xout$output[xout$output$ID==snames[i+2],]
    segmean <- rep(segout$seg.mean, segout$num.mark)
# gains and losses
    pfreq[ii] <- pfreq[ii] + 1
    gain[ii] <- gain[ii] + 1*((segmean - median(segmean))/xmad[i] > threshold)
    loss[ii] <- loss[ii] - 1*((segmean - median(segmean))/xmad[i] < -threshold)
  }
  out <- list()
  out$chrom <- xout$data$chrom
  out$maploc <- xout$data$maploc
  out$pfreq <- pfreq
  out$gain <- gain/pfreq
  out$loss <- loss/pfreq
  as.data.frame(out)
}

changepoints <- function(genomdat, data.type="logratio", alpha=0.01, weights=
                         NULL, sbdry, sbn, nperm=10000, p.method="hybrid", 
                         min.width=2, kmax=25, nmin=200, trimmed.SD=NULL, 
                         undo.splits="none", undo.prune=0.05, undo.SD=3,
                         verbose=1, ngrid=100, tol=1e-6)
  {
    n <- length(genomdat)
    if (missing(trimmed.SD)) trimmed.SD <- mad(diff(genomdat))/sqrt(2)
#   start with the whole 
    seg.end <- c(0,n)
    k <- length(seg.end)
    change.loc <- NULL
    weighted <- ifelse(is.null(weights), FALSE, TRUE) 
    while (k > 1)
      {
        current.n <- seg.end[k]-seg.end[k-1]
        if (verbose>=3) cat(".... current segment:",seg.end[k-1]+1,"-",seg.end[k],"\n")
        if(current.n >= 2*min.width) {
          current.genomdat <- genomdat[(seg.end[k-1]+1):seg.end[k]]
#   check whether hybrid method needs to be used
          hybrid <- FALSE
          delta <- 0
          if ((p.method=="hybrid") & (nmin < current.n)) {
            hybrid <- TRUE
            delta <- (kmax+1)/current.n
          }
#   call the changepoint routine
          if (weighted) {
#   get the weights for the current set of probes
            current.wts <- weights[(seg.end[k-1]+1):seg.end[k]]
            current.rwts <- sqrt(current.wts)
            current.cwts <- cumsum(current.wts)/sqrt(sum(current.wts))
#   if all values of current.genomdat are the same don't segment
            if (isTRUE(all.equal(diff(range(current.genomdat)), 0))) {
              zzz <- list()
              zzz$ncpt <- 0
            } else {
#   centering the current data will save a lot of computations later
              current.avg <- sum(current.genomdat*current.wts)/sum(current.wts)
              current.genomdat <- current.genomdat - current.avg
#   need total sum of squares too
              current.tss <- sum(current.wts*(current.genomdat^2))
              zzz <- .Fortran("wfindcpt",
                              n=as.integer(current.n),
                              x=as.double(current.genomdat),
                              tss=as.double(current.tss),
                              wts=as.double(current.wts),
                              rwts=as.double(current.rwts),
                              cwts=as.double(current.cwts),
                              px=double(current.n),
                              sx=double(current.n),
                              nperm=as.integer(nperm),
                              cpval=as.double(alpha),
                              ncpt=integer(1),
                              icpt=integer(2),
                              hybrid=as.logical(hybrid),
                              al0=as.integer(min.width),
                              hk=as.integer(kmax),
                              mncwt=double(kmax),
                              delta=as.double(delta),
                              ngrid=as.integer(ngrid),
                              sbn=as.integer(sbn),
                              sbdry=as.integer(sbdry),
                              tol= as.double(tol),
                              PACKAGE="DNAcopy")
            }
          } else { 
#   if all values of current.genomdat are the same don't segment
            if (isTRUE(all.equal(diff(range(current.genomdat)), 0))) {
              zzz <- list()
              zzz$ncpt <- 0
            } else {
#   centering the current data will save a lot of computations later
              current.avg <- mean(current.genomdat)
              current.genomdat <- current.genomdat - current.avg
#   need total sum of squares too
              current.tss <- sum(current.genomdat^2)
              zzz <- .Fortran("fndcpt",
                              n=as.integer(current.n),
                              x=as.double(current.genomdat),
                              tss=as.double(current.tss),
                              px=double(current.n),
                              sx=double(current.n),
                              nperm=as.integer(nperm),
                              cpval=as.double(alpha),
                              ncpt=integer(1),
                              icpt=integer(2),
                              ibin=as.logical(data.type=="binary"),
                              hybrid=as.logical(hybrid),
                              al0=as.integer(min.width),
                              hk=as.integer(kmax),
                              delta=as.double(delta),
                              ngrid=as.integer(ngrid),
                              sbn=as.integer(sbn),
                              sbdry=as.integer(sbdry),
                              tol= as.double(tol),
                              PACKAGE="DNAcopy")
            }
          }
        } else {
          zzz <- list()
          zzz$ncpt <- 0
        }
        if(zzz$ncpt==0) change.loc <- c(change.loc,seg.end[k])
        seg.end <- switch(1+zzz$ncpt,seg.end[-k],
                          c(seg.end[1:(k-1)],seg.end[k-1]+zzz$icpt[1],seg.end[k]),
                          c(seg.end[1:(k-1)],seg.end[k-1]+zzz$icpt,seg.end[k]))
        k <- length(seg.end)
        if(verbose>=3) cat(".... segments to go:",seg.end,"\n")
      }
    seg.ends <- rev(change.loc)
    nseg <- length(seg.ends)
    lseg <- diff(c(0,seg.ends))
    if (nseg > 1) {
        if (undo.splits == "prune") {
            lseg <- changepoints.prune(genomdat, lseg, undo.prune)
        }
        if (undo.splits == "sdundo") {
            lseg <- changepoints.sdundo(genomdat, lseg, trimmed.SD, undo.SD)
        }
    }
    segmeans <- 0*lseg
    ll <- uu <- 0
    for(i in 1:length(lseg)) {
      uu <- uu + lseg[i]
      if (weighted) {
        segmeans[i] <- sum(genomdat[(ll+1):uu]*weights[(ll+1):uu])/sum(weights[(ll+1):uu])
      } else {
        segmeans[i] <- mean(genomdat[(ll+1):uu])
      }
      ll <- uu
    }
    list("lseg" = lseg, "segmeans" = segmeans)
  }

changepoints.prune <- function(genomdat, lseg, change.cutoff=0.05) {
  n <- length(genomdat)
  nseg <- length(lseg)
  ncpt <- nseg-1
  zzz <- .Fortran("prune",
                  as.integer(n),
                  as.double(genomdat),
                  as.integer(nseg),
                  as.integer(lseg),
                  as.double(change.cutoff),
                  double(nseg),
                  as.integer(ncpt),
                  loc=integer(ncpt),
                  integer(2*ncpt),
                  pncpt=integer(1), PACKAGE="DNAcopy")
  pruned.ncpt <- zzz$pncpt
  pruned.cpts <- cumsum(lseg)[zzz$loc[1:pruned.ncpt]]
  pruned.lseg <- diff(c(0,pruned.cpts,n))
  pruned.lseg
}

changepoints.sdundo <- function(genomdat, lseg, trimmed.SD, change.SD=3) {
  change.SD <- trimmed.SD*change.SD
  cpt.loc <- cumsum(lseg)
  sdundo <- TRUE
  while(sdundo) {
    k <- length(cpt.loc)
    if (k>1) {
      segments0 <- cbind(c(1,1+cpt.loc[-k]),cpt.loc)
      segmed <- apply(segments0, 1, function(i,x) {median(x[i[1]:i[2]])}, genomdat)
      adsegmed <- abs(diff(segmed))
      if (min(adsegmed) < change.SD) {
        i <- which(adsegmed == min(adsegmed))
        cpt.loc <- cpt.loc[-i]
      } else {
        sdundo <- FALSE
      }
    } else {
      sdundo <- FALSE
    }
  }
  lseg.sdundo <- diff(c(0,cpt.loc))
  lseg.sdundo
}

trimmed.variance <- function(genomdat, trim=0.025)
  {
    n <- length(genomdat)
    n.keep <- round((1-2*trim)*(n-1))
    inflfact(trim)*sum((sort(abs(diff(genomdat)))[1:n.keep])^2 / (2*n.keep))
  }

inflfact <- function(trim)
  {
    a <- qnorm(1-trim)
    x <- seq(-a,a,length.out=10001)
    x1 <- (x[-10001] + x[-1])/2
    1/(sum(x1^2*dnorm(x1)/(1-2*trim))*(2*a/10000))
  }

      subroutine prune(n,x,nseg,lseg,pcut,sx,ncpt,loc,loc1,pncpt)
      integer n, nseg, lseg(nseg), ncpt, loc(ncpt), loc1(2,ncpt), pncpt
      double precision x(n), pcut, sx(nseg)

      integer i, j, k, kmj
      double precision ssq, wssqk, wssq1, wssqj
      logical jleft

      double precision errssq
      external errssq

      ssq = 0.0
      do 10 i = 1,n
         ssq = ssq + x(i)**2
 10   continue
      k = 0
      do 15 i = 1,nseg
         sx(i) = 0
         do 14 j = 1,lseg(i)
            k = k + 1
            sx(i) = sx(i) + x(k)
 14      continue
 15   continue

      k = nseg - 1
      do 16 i = 1,k
         loc(i) = i
         loc1(2,i) = i
 16   continue
      wssqk = ssq - errssq(nseg,lseg,sx,k,loc)
      do 100 j = k-1, 1, -1
         kmj = k - j
         jleft = .TRUE.
         do 20 i = 1,j
            loc(i) = i
            loc1(1,i) = i
 20      continue
         wssqj = ssq - errssq(nseg,lseg,sx,j,loc)
         do 30 while(jleft) 
            call combn(j, kmj, loc, jleft)
            wssq1 = ssq - errssq(nseg,lseg,sx,j,loc)
            if (wssq1 .le. wssqj) then
               wssqj = wssq1
               do 25 i = 1,j
                  loc1(1,i) = loc(i)
 25            continue
            endif
 30      continue
         if (wssqj/wssqk .gt. 1+pcut) then
            pncpt = j+1
            do 35 i = 1,pncpt
               loc(i) = loc1(2,i)
 35         continue
            return
         else
            do 40 i = 1,j
               loc1(2,i) = loc1(1,i)
 40         continue
         endif
 100  continue
      pncpt = 0
      return
      end

      double precision function errssq(nseg,lseg,sx,k,loc)
      integer nseg, lseg(nseg),k,loc(k)
      double precision sx(nseg)

      double precision segsx
      integer segnx, i, j

      errssq = 0.0
      segsx = 0.0
      segnx = 0
      do 10 i = 1,loc(1)
         segsx = segsx + sx(i)
         segnx = segnx + lseg(i)
 10   continue
      errssq = errssq + segsx**2/dble(segnx)
      do 20 j = 2,k
         segsx = 0.0
         segnx = 0
         do 15 i = loc(j-1)+1,loc(j)
            segsx = segsx + sx(i)
            segnx = segnx + lseg(i)
 15      continue
         errssq = errssq + segsx**2/dble(segnx)
 20   continue
      segsx = 0.0
      segnx = 0
      do 25 i = loc(k)+1,nseg
         segsx = segsx + sx(i)
         segnx = segnx + lseg(i)
 25   continue
      errssq = errssq + segsx**2/dble(segnx)

      return
      end
c
c     This program generates Choose(n,r) combinations one at a time
c     Adapted from Algorithm AS 88  Appl. Statist. (1975) Vol.24, No. 3
c     
      subroutine combn(r, nmr, loc, rleft)
      integer r, nmr, loc(r)
      logical rleft

      integer i,j

      i = r
      do 10 while (loc(i) .eq. nmr+i)
         i = i-1
 10   continue
      loc(i) = loc(i) + 1
      do 20 j = i+1,r
         loc(j) = loc(j-1)+1
 20   continue
      if (loc(1) .eq. nmr+1) rleft = .FALSE.

      return
      end

zoomIntoRegion <- function(x, chrom, sampleid, maploc.start=NULL, maploc.end=NULL, pt.pch=NULL, pt.cex=NULL, pt.col=NULL, segcol=NULL, seglwd=NULL, main=NULL, xlab=NULL, ylab=NULL, ...) {
  if (!inherits(x, 'DNAcopy')) stop("First arg must be a DNAcopy object")
  tmp <- subset(x, chrom=chrom[1], samplelist=sampleid[1])
  lrdata <- tmp$data
  if (missing(maploc.start)) maploc.start <- min(lrdata$maploc, na.rm=T) - 1
  if (missing(maploc.end)) maploc.end <- max(lrdata$maploc, na.rm=T) + 1
  ii <- ((lrdata$maploc >= maploc.start) & (lrdata$maploc <= maploc.end))
  if (missing(pt.pch)) pt.pch <- "."
  if (missing(pt.cex))
      pt.cex <- ifelse(pt.pch==".", 3, 1)
  if (missing(pt.col)) pt.col <- "green3"
  if (missing(segcol)) segcol <- "red"
  if (missing(seglwd)) seglwd <- 3
  if (missing(main)) 
      main <- paste("chr", chrom, ": ", maploc.start,"-", maploc.end, " from sample ", sampleid, sep="")
  if (missing(xlab)) xlab = "Genomic Position"
  if (missing(ylab)) ylab = "log-ratio"
  
  plot(lrdata[ii,2], lrdata[ii,3], main = main, xlab=xlab, ylab = ylab, pch = pt.pch, cex = pt.cex, col = pt.col, ...)
  segs <- tmp$output
  jj <- ((segs$loc.start <= maploc.end) & (segs$loc.end >= maploc.start))
  segs <- segs[jj,]
  k <- nrow(segs)
  segs$loc.start[1] <- maploc.start
  segs$loc.end[k] <- maploc.end
  segments(segs$loc.start, segs$seg.mean, x1=segs$loc.end, y1=segs$seg.mean, col = segcol, lwd = seglwd)
#  for(i in 1:k) {
#    lines(c(segs$loc.start[i],segs$loc.end[i]), rep(segs$seg.mean[i],2), col=segcol, lwd=seglwd)
#  }
}

plotSample <- function(x, sampleid=NULL, chromlist=NULL, xmaploc=FALSE,
                       col=c("black","green"), pch=".", cex=NULL, altcol=TRUE,
                       segcol="red", lwd=3, zeroline=TRUE, zlcol="grey",
                       xlab=NULL, ylab=NULL, main=NULL, ...) {
  if (!inherits(x, 'DNAcopy')) stop("First arg must be a DNAcopy object")
  if (missing(sampleid)) {sampleid <- 1}
  subx <- subset(x, chromlist=chromlist, samplelist=sampleid[1])
# get the data for plotting
  genomdat <- subx$data[,3]
  ina <- is.finite(genomdat)
  genomdat <- genomdat[ina]
  chrom <- subx$data[ina,1]
  uchrom <- unique(chrom)
  segres <- subx$output
# setup the X-axis based on xmaploc
  if (xmaploc) {
    maploc <- subx$data[ina,2]
    rmaploc <- sapply(uchrom, function(i, maploc, chrom) range(maploc[chrom==i]), maploc, chrom)
    nc <- length(uchrom)
    if ((nc>1) && any(rmaploc[1,-1] < rmaploc[2,-nc])) {
      cmaploc <- cumsum(as.numeric(rmaploc[2,]))
      for (i in 2:nc) {
        maploc[chrom==uchrom[i]] <- cmaploc[i-1] + maploc[chrom==uchrom[i]] 
      }
    }
    xlabel <- "Genomic Position"
  } else {
    maploc <- 1:sum(ina)
    xlabel <- "Index"
  }
# setup altenating colors
  if (altcol & length(uchrom)>1) {
    colvec <- rep(1, length(chrom))
    j <- 0
    for(i in uchrom) {
      j <- (j+1) %% 2
      colvec[chrom == i] <- j+1
    }
  } else {
    colvec <- 1
  }
# set other graphical parameters
  if (missing(cex)) cex <- ifelse(pch == ".", 3, 1)
  if (missing(main)) main <- names(subx$data)[3]
  if (missing(xlab)) xlab <- xlabel
  if (missing(ylab)) {
    if (attr(subx$data, "data.type") == "logratio") {ylab <- "log(relative CN)"}
    else {ylab <- "LOH"}
  }
# plot the data
  plot(maploc, genomdat, col=col[colvec], pch=pch, cex=cex, main=main, xlab=xlab, ylab=ylab, ...)
# add the segment means
  ii <- cumsum(c(0, segres$num.mark))
  mm <- segres$seg.mean
  kk <- length(ii)
  segments(maploc[ii[-kk]+1], segres$seg.mean, x1=maploc[ii[-1]], y1=segres$seg.mean, col = segcol, lwd=lwd)
#  for (i in 1:(kk - 1)) {
#    lines(maploc[c(ii[i]+1,ii[i+1])], rep(mm[i], 2), col = segcol, lwd=lwd)
#  }
# add the zeroline
  if (zeroline) abline(h=0, col=zlcol, lwd=lwd)
}

c     Ternary segmentation with permutation reference distribution
c     probes have weights due to differences in variances

      subroutine wfindcpt(n,x,tss,wts,rwts,cwts,px,sx,nperm,cpval,ncpt,
     1     icpt,hybrid,al0,hk,mncwt,delta,ngrid,sbn,sbdry,tol)
      integer n,nperm,ncpt,icpt(2),al0,hk,ngrid,sbn,sbdry(sbn)
      logical hybrid
      double precision x(n),tss,wts(n),rwts(n),cwts(n),px(n),sx(n),
     1     cpval,mncwt(hk),delta,tol

      integer np,nrej,nrejc,iseg(2),n1,n2,n12,l,k
      double precision ostat,ostat1,pstat,tpval,pval1,pval2

c     new functions to replace tmax and htmax (also tmaxo replaces tmax1)
      double precision tailp, wtmaxp, hwtmaxp, wtpermp
      external tailp, wtmaxp, hwtmaxp, wtpermp

      call rndstart()

      nrej = 0
      ncpt = 0

c     call the observed statistic routine
      call wtmaxo(n,x,wts,tss,sx,cwts,iseg,ostat,al0)
      ostat1 = sqrt(ostat)
      ostat = ostat * 0.99999

c     if maximal t-statistic is too small (for now use 0.1) don't split
      if (ostat1 .le. 0.1) go to 500
c     if maximal t-statistic is too large (for now use 7.0) split
c     also make sure it's not affected by outliers i.e. small seglength
      l = min(iseg(2) - iseg(1), n - iseg(2) + iseg(1))
      if ((ostat1 .ge. 7.0) .and. (l .ge. 10)) go to 200
c     o.w calculate p-value and decide if & how data are segmented
      if (hybrid) then
         call getmncwt(n, cwts, hk, mncwt, delta)
c     delta is a function of arc lengths
         pval1 = tailp(ostat1, delta, n, ngrid, tol)
         if (pval1 .gt. cpval) go to 500
         pval2 = cpval - pval1
         nrejc = int(pval2*dble(nperm))
         k=nrejc*(nrejc+1)/2 + 1
         do 50 np = 1,nperm
c     call permutation code for data with weights
            call wxperm(n,x,px,rwts)
c     call the small arc permutation statistic function
            pstat = hwtmaxp(n,hk,px,wts,sx,cwts,mncwt,al0)
            if (ostat.le.pstat) then
               nrej = nrej + 1
               k = k + 1
            endif
            if (nrej.gt.nrejc) go to 500
            if (np .ge. sbdry(k)) go to 200
 50      continue
      else
         nrejc = int(cpval*dble(nperm))
         k=nrejc*(nrejc+1)/2 + 1
         do 100 np = 1,nperm
c     call permutation code for data with weights
            call wxperm(n,x,px,rwts)
c     call full data permutation statistic function
            pstat = wtmaxp(n,px,wts,sx,cwts,al0)
            if (ostat.le.pstat) then
               nrej = nrej + 1
               k = k + 1
            endif
            if (nrej.gt.nrejc) go to 500
            if (np .ge. sbdry(k)) go to 200
 100     continue
      endif
 200  if (iseg(2).eq.n) then
         ncpt = 1
         icpt(1) = iseg(1)
      else
         if(iseg(1).eq.0) then
            ncpt = 1
            icpt(1) = iseg(2)
         else
            l = 1
            n1 = iseg(1)
            n12 = iseg(2)
            n2 = n12 - n1
            tpval = wtpermp(n1,n2,n12,x(l),px,wts(l),rwts(l),nperm)
            if (tpval.le.cpval) then
               ncpt = 1
               icpt(1) = iseg(1)
            endif
            l = iseg(1) + 1
            n12 = n - iseg(1)
            n2 = n - iseg(2)
            n1 = n12 - n2
            tpval = wtpermp(n1,n2,n12,x(l),px,wts(l),rwts(l),nperm)
            if (tpval.le.cpval) then
               ncpt = ncpt + 1
               icpt(ncpt) = iseg(2)
            endif
         endif
      endif

 500  call rndend()

      return
      end

c     *******  code to permute the data vector with weights  ********
c     since variance of probe i is inversely proportional to weights 
c     multiply by square root, permute and then divide by square root
      subroutine wxperm(n,x,px,rwts)
      integer n
      double precision x(n),px(n),rwts(n)

      integer i,j
      double precision cc,tmpx

      double precision dunif
      external dunif

      do 10 i = 1,n
         px(i) = x(i)*rwts(i)
 10   continue

      do 20 i = n,1,-1
         cc = dunif()
         j = int(cc*dble(i))+1
         tmpx = px(i)
         px(i) = px(j)/rwts(i)
         px(j) = tmpx
 20   continue

      return
      end

c     function for the p-value of t-statistics for removing edge effects
      double precision function wtpermp(n1,n2,n,x,px,wts,rwts,nperm)
      integer n1,n2,n,nperm
      double precision x(n),px(n),wts(n),rwts(n)

      integer np,i,m1,j,nrej
      double precision xsum1,xsum2,xbar,ostat,pstat,rn1,rn2,rm1,
     1     tstat, tss, rn, cc, tmpx

      double precision dunif
      external dunif

      if (n1.eq.1 .or. n2.eq.1) then
         nrej = nperm
         go to 110
      endif
      xsum1 = 0.0
      tss = 0.0
      rn1 = 0.0
      do 10 i=1,n1
         px(i) = x(i)*rwts(i)
         xsum1 = xsum1 + wts(i)*x(i)
         tss = tss + wts(i)*x(i)**2
         rn1 = rn1 + wts(i)
 10   continue
      xsum2 = 0.0
      rn2 = 0.0
      do 20 i=n1+1,n
         px(i) = x(i)
         xsum2 = xsum2 + wts(i)*x(i)
         tss = tss + wts(i)*x(i)**2
         rn2 = rn2 + wts(i)
 20   continue
      rn = rn1 + rn2
      xbar = (xsum1 + xsum2)/rn
      tss = tss - rn*(xbar**2)
      if (n1.le.n2) then
         m1 = n1
         rm1 = rn1
         ostat = 0.99999*abs(xsum1/rn1 - xbar)
         tstat = (ostat**2)*rn1*rn/rn2
      else
         m1 = n2
         rm1 = rn2
         ostat = 0.99999*abs(xsum2/rn2 - xbar)
         tstat = (ostat**2)*rn2*rn/rn1
      endif
      nrej = 0
      tstat = tstat/((tss-tstat)/(dble(n)-2.0))
c     if observed t is large (> 5) don't bother with permutation p-value
c     also make sure there are enough observations i.e. m1 >= 10
      if ((tstat .gt. 25) .and. (m1 .ge. 10)) go to 110
      do 100 np = 1,nperm
         xsum1 = 0
         do 30 i = n,n-m1+1,-1
            cc = dunif()
            j = int(cc*dble(i))+1
            tmpx = px(i)
            px(i) = px(j)
            px(j) = tmpx
c     the observation should be divided by sqrt(wts(i)) to get the correct 
c     probe variance.  But should be multiplied by wts(i) for statistic
            xsum1 = xsum1 + px(i)*rwts(i)
 30      continue
         pstat = abs(xsum1/rm1 - xbar)
         if (ostat.le.pstat) nrej = nrej + 1
 100  continue
 110  wtpermp = dble(nrej)/dble(nperm)

      return
      end

c     Ternary segmentation with permutation reference distribution
      subroutine fndcpt(n,x,tss,px,sx,nperm,cpval,ncpt,icpt,ibin,
     1     hybrid,al0,hk,delta,ngrid,sbn,sbdry,tol)
      integer n,nperm,ncpt,icpt(2),al0,hk,ngrid,sbn,sbdry(sbn)
      logical ibin,hybrid
      double precision x(n),tss,px(n),sx(n),cpval,delta,tol

      integer np,nrej,nrejc,iseg(2),n1,n2,n12,l,k
      double precision ostat,ostat1,pstat,tpval,pval1,pval2

c     new functions to replace tmax and htmax (also tmaxo replaces tmax1)
      double precision tailp, tmaxp, htmaxp, tpermp
      external tailp, tmaxp, htmaxp, tpermp

      call rndstart()

      nrej = 0
      ncpt = 0

c      call tmax1(n,twon,x,tss,sx,tx,iseg,ostat,ibin)
      call tmaxo(n,x,tss,sx,iseg,ostat,al0,ibin)
      ostat1 = sqrt(ostat)
      ostat = ostat * 0.99999
c      call dblepr("Max Stat",8,ostat,1)
c      call intpr("Location",8,iseg,2)

c     if maximal t-statistic is too small (for now use 0.1) don't split
      if (ostat1 .le. 0.1) go to 500
c     if maximal t-statistic is too large (for now use 7.0) split
c     also make sure it's not affected by outliers i.e. small seglength
      l = min(iseg(2) - iseg(1), n - iseg(2) + iseg(1))
      if ((ostat1 .ge. 7.0) .and. (l .ge. 10)) go to 200
c     o.w calculate p-value and decide if & how data are segmented
      if (hybrid) then
         pval1 = tailp(ostat1, delta, n, ngrid, tol)
         if (pval1 .gt. cpval) go to 500
         pval2 = cpval - pval1
         nrejc = int(pval2*dble(nperm))
         k=nrejc*(nrejc+1)/2 + 1
         do 50 np = 1,nperm
            call xperm(n,x,px)
c            pstat = htmax(n,twon,hk,tss,px,sx,tx,ibin)
            pstat = htmaxp(n,hk,tss,px,sx,al0,ibin)
            if (ostat.le.pstat) then
               nrej = nrej + 1
               k = k + 1
            endif
            if (nrej.gt.nrejc) go to 500
            if (np .ge. sbdry(k)) go to 200
 50      continue
      else
         nrejc = int(cpval*dble(nperm))
         k=nrejc*(nrejc+1)/2 + 1
         do 100 np = 1,nperm
            call xperm(n,x,px)
c            pstat = tmax(n,twon,tss,px,sx,tx,ibin)
            pstat = tmaxp(n,tss,px,sx,al0,ibin)
c     call dblepr("Perm Max Stat",13,pstat,1)
            if (ostat.le.pstat) then
               nrej = nrej + 1
               k = k + 1
            endif
c     call intpr("num rej",7,nrej,1)
            if (nrej.gt.nrejc) go to 500
            if (np .ge. sbdry(k)) go to 200
 100     continue
      endif
 200  if (iseg(2).eq.n) then
         ncpt = 1
         icpt(1) = iseg(1)
      else
         if(iseg(1).eq.0) then
            ncpt = 1
            icpt(1) = iseg(2)
         else
            l = 1
            n1 = iseg(1)
            n12 = iseg(2)
            n2 = n12 - n1
            tpval = tpermp(n1,n2,n12,x(l),px,nperm)
c            call dblepr("binseg p-value",14,tpval,1)
            if (tpval.le.cpval) then
               ncpt = 1
               icpt(1) = iseg(1)
            endif
            l = iseg(1) + 1
            n12 = n - iseg(1)
            n2 = n - iseg(2)
            n1 = n12 - n2
            tpval = tpermp(n1,n2,n12,x(l),px,nperm)
c            call dblepr("binseg p-value",14,tpval,1)
            if (tpval.le.cpval) then
               ncpt = ncpt + 1
               icpt(ncpt) = iseg(2)
            endif
         endif
      endif

 500  call rndend()

      return
      end

c     code to permute the data vector
      subroutine xperm(n,x,px)
      integer n
      double precision x(n),px(n)

      integer i,j
      double precision cc,tmpx

      double precision dunif
      external dunif

      do 10 i = 1,n
         px(i) = x(i)
 10   continue

      do 20 i = n,1,-1
         cc = dunif()
         j = int(cc*dble(i))+1
         tmpx = px(i)
         px(i) = px(j)
         px(j) = tmpx
 20   continue
      return
      end

c     function for the p-value of t-statistics for removing edge effects
      double precision function tpermp(n1,n2,n,x,px,nperm)
      integer n1,n2,n,nperm
      double precision x(n),px(n)

      integer np,i,m1,j,nrej
      double precision xsum1,xsum2,xbar,ostat,pstat,rn1,rn2,rm1,
     1     tstat, tss, rn, cc, tmpx

      double precision dunif
      external dunif

      rn1 = dble(n1)
      rn2 = dble(n2)
      rn = rn1 + rn2
      if (n1.eq.1 .or. n2.eq.1) then
         nrej = nperm
         go to 110
      endif
      xsum1 = 0.0
      tss = 0.0
      do 10 i=1,n1
         px(i) = x(i)
         xsum1 = xsum1 + x(i)
         tss = tss + x(i)**2
 10   continue
      xsum2 = 0.0
      do 20 i=n1+1,n
         px(i) = x(i)
         xsum2 = xsum2 + x(i)
         tss = tss + x(i)**2
 20   continue
      xbar = (xsum1 + xsum2)/rn
      tss = tss - rn*(xbar**2)
      if (n1.le.n2) then
         m1 = n1
         rm1 = rn1
         ostat = 0.99999*abs(xsum1/rn1 - xbar)
         tstat = (ostat**2)*rn1*rn/rn2
      else
         m1 = n2
         rm1 = rn2
         ostat = 0.99999*abs(xsum2/rn2 - xbar)
         tstat = (ostat**2)*rn2*rn/rn1
      endif
c      call dblepr("O-Stat",6,ostat,1)
      nrej = 0
      tstat = tstat/((tss-tstat)/(rn-2.0))
c      call dblepr("T-square",8,tstat,1)
c     if observed t is large (> 5) don't bother with permutation p-value
c     also make sure there are enough observations i.e. m1 >= 10
      if ((tstat .gt. 25) .and. (m1 .ge. 10)) go to 110
      do 100 np = 1,nperm
c*******************************************
c     the following is very inefficient
c*******************************************
c         call xperm(n,x,px)
c         xsum1 = 0.0
c         do 30 i=1,m1
c            xsum1 = xsum1 + px(i)
c 30      continue
c*******************************************
c     changed to the following: instead of
c     full permutation sample m1 w.o. repl
c******************************************* 
         xsum1 = 0
         do 30 i = n,n-m1+1,-1
            cc = dunif()
            j = int(cc*dble(i))+1
            tmpx = px(i)
            px(i) = px(j)
            px(j) = tmpx
            xsum1 = xsum1 + px(i)
 30      continue
         pstat = abs(xsum1/rm1 - xbar)
c         call dblepr("P-Stat",6,pstat,1)
         if (ostat.le.pstat) nrej = nrej + 1
 100  continue
 110  tpermp = dble(nrej)/dble(nperm)

      return
      end

segment <- function(x, weights=NULL, alpha=0.01, nperm=10000, p.method= 
                    c("hybrid","perm"), min.width=2, kmax=25, nmin=200, 
                    eta=0.05, sbdry=NULL, trim = 0.025, undo.splits=
                    c("none","prune", "sdundo"), undo.prune=0.05, undo.SD=3,
                    verbose=1)
  {
    if (!inherits(x, 'CNA')) stop("First arg must be a copy number array object")
    call <- match.call()
    if (min.width < 2 | min.width > 5) stop("minimum segment width should be between 2 and 5")
    if (nmin < 4*kmax) stop("nmin should be >= 4*kmax")
    if (missing(sbdry)) {
      if (nperm==10000 & alpha==0.01 & eta==0.05) {
        if (!exists("default.DNAcopy.bdry")) data(default.DNAcopy.bdry, package="DNAcopy",envir=environment())
        sbdry <- get("default.DNAcopy.bdry", envir=environment())
      } else {
        max.ones <- floor(nperm*alpha) + 1
        sbdry <- getbdry(eta, nperm, max.ones)
      }
    }
    weighted <- ifelse(missing(weights), FALSE, TRUE)
#   rudimentary error checking for weights
    if (weighted) {
      if (length(weights) != nrow(x)) stop("length of weights should be the same as the number of probes")
      if (min(weights) <= 0) stop("all weights should be positive")
    }
    sbn <- length(sbdry)
    nsample <- ncol(x)-2
    sampleid <- colnames(x)[-(1:2)]
    uchrom <- unique(x$chrom)
    data.type <- attr(x, "data.type")
    p.method <- match.arg(p.method)
    undo.splits <- match.arg(undo.splits)
    segres <- list()
    segres$data <- x
    allsegs <- list()
    allsegs$ID <- NULL
    allsegs$chrom <- NULL
    allsegs$loc.start <- NULL
    allsegs$loc.end <- NULL
    allsegs$num.mark <- NULL
    allsegs$seg.mean <- NULL
    segRows <- list()
    segRows$startRow <- NULL
    segRows$endRow <- NULL
    for (isamp in 1:nsample) {
      if (verbose>=1) cat(paste("Analyzing:", sampleid[isamp],"\n"))
      genomdati <- x[,isamp+2]
      ina <- which(is.finite(genomdati))
      genomdati <- genomdati[ina]
      trimmed.SD <- sqrt(trimmed.variance(genomdati, trim))
      chromi <- x$chrom[ina]
#      maploci <- x$maploc[ina]
      if (weighted) {
        wghts <- weights[ina]
      } else {
        wghts <- NULL
      }
      sample.lsegs <- NULL
      sample.segmeans <- NULL
      for (ic in uchrom) {
        if (verbose>=2) cat(paste("  current chromosome:", ic, "\n"))
        segci <- changepoints(genomdati[chromi==ic], data.type, alpha,
                              wghts[chromi==ic], sbdry, sbn, nperm, p.method,
                              min.width, kmax, nmin, trimmed.SD, undo.splits,
                              undo.prune, undo.SD, verbose)
        sample.lsegs <- c(sample.lsegs, segci$lseg)
        sample.segmeans <- c(sample.segmeans, segci$segmeans)
      }
      sample.nseg <- length(sample.lsegs)
      sample.segs.start <- ina[cumsum(c(1,sample.lsegs[-sample.nseg]))]
      sample.segs.end <- ina[cumsum(sample.lsegs)]
      allsegs$ID <- c(allsegs$ID, rep(isamp,sample.nseg))
      allsegs$chrom <- c(allsegs$chrom, x$chrom[sample.segs.end])
      allsegs$loc.start <- c(allsegs$loc.start, x$maploc[sample.segs.start])
      allsegs$loc.end <- c(allsegs$loc.end, x$maploc[sample.segs.end])
      allsegs$num.mark <- c(allsegs$num.mark, sample.lsegs)
      allsegs$seg.mean <- c(allsegs$seg.mean, sample.segmeans)
      segRows$startRow <- c(segRows$startRow, sample.segs.start)
      segRows$endRow <- c(segRows$endRow, sample.segs.end)
    }
    allsegs$ID <- sampleid[allsegs$ID]
    allsegs$seg.mean <- round(allsegs$seg.mean, 4)
    allsegs <- as.data.frame(allsegs)
    allsegs$ID <- as.character(allsegs$ID)
    segres$output <- allsegs
    segres$segRows <- as.data.frame(segRows)
    segres$call <- call
    if (weighted) segres$weights <- weights
    class(segres) <- "DNAcopy"
    segres
  }

%\VignetteIndexEntry{DNAcopy}
%\VignetteDepends{}
%\VignetteKeywords{DNA Copy Number Analysis}
%\VignettePackage{DNAcopy}

\documentclass[11pt]{article}

\usepackage{amsmath}
\usepackage[authoryear,round]{natbib}
\usepackage{hyperref}
\SweaveOpts{echo=FALSE}

\setlength{\textheight}{8.5in}
\setlength{\textwidth}{6in}
\setlength{\topmargin}{-0.25in}
\setlength{\oddsidemargin}{0.25in}
\setlength{\evensidemargin}{0.25in}

\begin{document}
\setkeys{Gin}{width=0.99\textwidth}


\title{\bf DNAcopy: A Package for Analyzing DNA Copy Data}

\author{Venkatraman E. Seshan$^1$ and Adam B. Olshen$^2$}

\maketitle

\begin{center}
$^1$Department of Epidemiology and Biostatistics\\
Memorial Sloan-Kettering Cancer Center\\
{\tt seshanv@mskcc.org}\\
\ \\
$^2$Department of Epidemiology and Biostatistics\\
University of California, San Francisco\\
{\tt olshena@biostat.ucsf.edu}
\end{center}

\tableofcontents

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Overview}

This document presents an overview of the {\tt DNAcopy} package. This
package is for analyzing array DNA copy number data, which is usually
(but not always) called array Comparative Genomic Hybridization (array
CGH) data \citep{pinkel98, snijders01, wigler03}.  It implements our
methodology for finding change-points in these data \citep{olshen04},
which are points after which the (log) test over reference ratios have
changed location.  Our model is that the change-points
correspond to positions where the underlying DNA copy number has
changed.  Therefore, change-points can be used to identify regions of
gained and lost copy number.  We also provide a function for making
relevant plots of these data.

\section{Data}

We selected a subset of the data set presented in \cite{snijders01}.
We are calling this data set {\tt coriell}.  The data correspond to
two array CGH studies of fibroblast cell strains.  In particular, we
chose the studies {\bf GM05296} and {\bf GM13330}.  After selecting
only the mapped data from chromosomes 1-22 and X, there are 2271 data
points.  There is accompanying spectral karyotype data (not included),
which can serve
as a gold standard.  The data can be found at \\
\url{http://www.nature.com/ng/journal/v29/n3/suppinfo/ng754_S1.html}

\section{An Example}

Here we perform an analysis on the {\bf GM05296} array CGH study
described above.


<<echo=TRUE,print=FALSE>>=
library(DNAcopy)
@ 

<<echo=TRUE,print=FALSE>>=
data(coriell)
@ 

\noindent
Before segmentation the data needs to be made into a CNA object.

<<echo=TRUE,print=FALSE>>=
CNA.object <- CNA(cbind(coriell$Coriell.05296),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid="c05296")
@ 

\noindent
We generally recommend smoothing single point outliers before
analysis.  It is a good idea to check that the smoothing is proper for
a particular data set.

<<echo=TRUE,print=FALSE>>=
smoothed.CNA.object <- smooth.CNA(CNA.object)
@ 

\noindent
After smoothing, if necessary, the segmentation is run.  Here the
default parameters are used.  A brief discussion of parameters that
can be adjusted is in the Tips section.

<<echo=TRUE,print=FALSE>>=
segment.smoothed.CNA.object <- segment(smoothed.CNA.object, verbose=1)
@

%Plot whole studies

\noindent
There are a number of plots that can be made.  The first is ordering
the data by chromosome and map positons.  The red lines correspond to
mean values in segments.  Note that the points are in alternate colors
to indicate different chromosomes.

\pagebreak

\begin{center}
<<fig=TRUE,echo=TRUE>>=
plot(segment.smoothed.CNA.object, plot.type="w")
@
\end{center}

\noindent
Another possibility is to plot by chromosome within a study.

\begin{center}
<<fig=TRUE,echo=TRUE,width=11,height=9>>=
plot(segment.smoothed.CNA.object, plot.type="s") 
@
\end{center}

%Plot each chromosome across studies (6 per page)

%\begin{center}
%<<fig=FALSE,echo=TRUE>>=
%plot(segment.smoothed.CNA.object, plot.type="c", 
%     cbys.layout=c(2,1), 
%     cbys.nchrom=6)
%@
%\end{center}

%Plot by plateaus

\noindent
If there are multiple studies, one could plot by chromosome across
studies using the option {\tt plot.type='c'}.  A final plot orders the
segment by their chromosome means.  One can take the plateaus in this
plot to determine what the mean values should be for calling segments
gains or losses.  In this case, maybe $0.4$ for gains and $-0.6$ for
losses.  For most data, these plateaus are much closer to zero.  The
next generation of this software will have automatic methods for
calling gains and losses.

\begin{center}
<<fig=TRUE,echo=TRUE>>=
plot(segment.smoothed.CNA.object, plot.type="p")
@
\end{center}

\noindent
Change-points are often found due to local trends in the data.  An
undo method is needed to get rid of unnecessary change-points.  Below all
splits that are not at least three SDs apart are removed.  The
following plot shows that all splits not corresponding to the gold
standard results have been removed.

<<echo=TRUE,print=FALSE,width=6,height=5>>=
sdundo.CNA.object <- segment(smoothed.CNA.object, 
                             undo.splits="sdundo", 
                             undo.SD=3,verbose=1)
@ 


\begin{center}
<<fig=TRUE,echo=TRUE,width=11,height=9>>=
plot(sdundo.CNA.object,plot.type="s")
@
\end{center}

\section{Tips}

\noindent
A function that may be of interest that has not been mentioned is {\tt
  subset.CNA}.  It allows for subsetting of a CNA object by chromosome and
sample so that segmentation does not have to be run on a whole data set.
Similarly, {\tt subset.DNAcopy} allows subsetting of DNAcopy objects, which
contain the output of segmentation.

The original default segmentation algorithm, because it was based on
permutation, took $O(N^2)$ computations, where $N$ is the number of markers on
a chromosome.  The new default algorithm is much faster.  It includes a hybrid
approach to compute the $p$-value for segmenting based partly on permutation
and partly on a Gaussian approximation (available in all versions after 1.2.0) 
and a stopping rule (available in all versions after 1.5.0) to declare change
when there is a strong evidence for its presence \citep{venkat07}.  We no
longer recommend using overlapping windows for larger data sets.  It is still
possible to run the full permutations analysis using the option {\tt
  p.method='perm'}.  If the new algorithm is still too slow, one can reduce the
number of permutations in the hybrid method using the parameter {\tt nperm}
(default is 10,000).  However, the lower {\tt alpha} (the significance level
for the test to accept change-points) is, the more permutations that are
needed.  The stopping boundary needs to be computed for any choice of {\tt
  nperm} and {\tt alpha} which is not the default which is done automatically
within the function {\tt segment} or can be done externally using the function
{\tt getbdry} and passed on to {\tt segment}.

%\newpage
\bibliographystyle{apalike}
\bibliography{DNAcopy}

\end{document}

\name{subset.DNAcopy}
\alias{subset.DNAcopy}
\title{Subset a DNAcopy data object}
\description{
   Function to return a subset of a copy number array data object by a
   list of chromosomes and sample.
}
\usage{
  \method{subset}{DNAcopy}(x, chromlist=NULL, samplelist=NULL, ...)
}                          
\arguments{
  \item{x}{DNAcopy object}
  \item{chromlist}{chromosomes of interest.  Should be a subset of the
    valid chromosome names in the original data.}
  \item{samplelist}{samples of interest.  Can be integers denoting the
    samples of interest or a vector of valid sample names.}
  \item{...}{other arguments which may be passed to \code{subset}.}
}
\value{
  An object of class \code{DNAcopy} with the input data and the results
  of segmenting them only for the chromosomes and samples of interest.
}
\keyword{nonparametric}

\name{smooth.CNA}
\alias{smooth.CNA}
\title{Smooth a `Copy Number Array' data object}
\description{
  Detect outliers and smooth the data prior to analysis by programs such
  as circular binary segmentation (CBS). 
}
\usage{
  smooth.CNA(x, smooth.region=10, outlier.SD.scale=4, smooth.SD.scale=2,
                trim=0.025)
}                          
\arguments{
  \item{x}{Copy number array data object}
  \item{smooth.region}{number of points to consider on the left and the
    right of a point to detect it as an outlier. (default=10)}
  \item{outlier.SD.scale}{the number of SDs away from the nearest point
    in the smoothing region to call a point an outlier.}
  \item{smooth.SD.scale}{the number of SDs from the median in the
    smoothing region where a smoothed point is positioned.}
  \item{trim}{proportion of data to be trimmed for variance calculation
    for smoothing outliers and undoing splits based on SD.}
}
\value{
  An object of class \code{CNA} with outliers smoothed i.e the logratio
  values of singleton outliers is shrunk towards the values of its
  neighbors. The output is of the same dimension as the input.
}
\examples{

data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

#We generally recommend smoothing single point outliers before analysis
#Make sure to check that the smoothing is proper

smoothed.CNA.object <- smooth.CNA(CNA.object)

}

\keyword{nonparametric}

\name{getbdry}
\alias{getbdry}
\alias{default.DNAcopy.bdry}
\title{Sequential stopping boundary}
\description{
   Function to compute the sequential boundary for early stopping.
}
\usage{
  getbdry(eta, nperm, max.ones, tol= 1e-2)
}                          
\arguments{
  \item{eta}{Type I error rate of the boundary.}
  \item{nperm}{Number of permutations for the reference distribution.}
  \item{max.ones}{maximum number of ones given by "floor(nperm*alpha)+1".} 
  \item{tol}{tolerance level for the iterations.}
}
\value{
  A vector integer values of length max.ones*(max.ones+1)/2 corresponding
  to the boundary for the number of ones from 1 to max.ones. The default
  boundary for nperm=10000, eta=0.05, alpha=0.01 is stored in the data
  object "default.DNAcopy.bdry".  Use this function to get the boundary
  for your favorite values for the parameters "nperm, eta, alpha" and use
  it for the argument "sbdry" in the function "segment."
}
\keyword{nonparametric}

\name{glFrequency}
\alias{glFrequency}
\title{Additional summary measured for the segments}
\description{
  This program computes the frequency of gains and losses for each probe
  as a function of level of mad.
}
\usage{
  glFrequency(xout, threshold=1)
}
\arguments{
  \item{xout}{an object of class DNAcopy}
  \item{threshold}{threshold value to call gain or loss}
}
\value{
  A segment is called a gain or loss if the segment mean is at least the
  threshold* mad distance away from the median copy number level.  The
  output is a data frame with five columns which give the chromosome
  (chrom), genomic position (maploc), the number of samples with
  available data (pfreq), and the gain (gain) and loss (loss).
}

\author{Venkatraman E. Seshan}

\keyword{nonparametric}

\name{zoomIntoRegion}
\alias{zoomIntoRegion}
\title{Zoomed in view of genomic region}
\description{
  This program computes the frequency of gains and losses for each probe
  as a function of level of mad.
}
\usage{
  zoomIntoRegion(x, chrom, sampleid, maploc.start=NULL, maploc.end=NULL,
      pt.pch=NULL, pt.cex=NULL, pt.col=NULL, segcol=NULL, seglwd=NULL,
      main=NULL, xlab=NULL, ylab=NULL, ...)
}
\arguments{
  \item{x}{an object of class DNAcopy.}
  \item{chrom}{the chromosome in which the region lies.}
  \item{sampleid}{the sample of interest.}
  \item{maploc.start}{genomic start position of the region of interest.
    Default is the beginning of the chromosome.} 
  \item{maploc.end}{genomic end position of the region of interest.
    Default is the end of the chromosome.}
  \item{pt.pch}{the plotting character used for plotting the log-ratio
    values (default is ".").}
  \item{pt.cex}{the size of plotting character used for the log-ratio
    values (default is 3 if "." and 1 otherwise).}
  \item{pt.col}{the color used for the points. Default is green3.}
  \item{segcol}{the color of the lines indicating the segment means. If
    missing the line color is set to be red.} 
  \item{seglwd}{line weight of lines for segment mean and zeroline.  If
    missing it is set to 3.}
  \item{main}{figure title. If missing will be generated by pasting the
    chromosome, range and sample name together.}
  \item{xlab}{x-axis label. If missing "Genomic position" will be used}
  \item{ylab}{y-axis label. If missing "log-ratio" will be used}
  \item{...}{additional plotting options.}
}
\details{
  This command plots the region of interest with the log-ratio and
  segments.  It works for a region from a single chromosome in a single
  sample.  So if more than one chromosome and/or one sample are given
  only the first chromosome from the first sample will be used.
}

\examples{
data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

#We generally recommend smoothing single point outliers before analysis
#Make sure to check that the smoothing is proper

smoothed.CNA.object <- smooth.CNA(CNA.object)

#Segmentation at default parameters

segment.smoothed.CNA.object <- segment(smoothed.CNA.object, verbose=1)

zoomIntoRegion(segment.smoothed.CNA.object, chrom=10, sampleid="c05296")
}

\author{Venkatraman E. Seshan \email{seshanv@mskcc.org} }

\keyword{nonparametric}

\name{coriell}
\alias{coriell}
\title{Array CGH data set of Coriell cell lines}
\description{
  These are two data array CGH studies sets of Corriel cell lines taken
  from the reference below.
}
\usage{data(coriell)}
\format{A data frame containing five variables: first is clone name,
  second is clone chromosome, third is clone position, fourth (sample
  GM05296 from Web Table G) and fifth (sample GM13330 from Web Table H)
  are log2ratio for two cell lines.}
\source{
  Supplementary Information from https://www.nature.com/articles/ng754
}
\references{Snijders et al., Assembly of microarrays for genome-wide
  measurement of DNA copy number, \emph{Nature Genetics}, 2001}
\keyword{datasets}

\name{cytoBand}
\alias{cytoBand}
\title{Cytogenic band data}
\description{
  Cytogenic band data from the goldenPath repository
}
\usage{data(cytoBand)}
\format{A data frame containing five variables: chromosome, start and
  end positions, band name and giesma stain.
}
\source{
  http://hgdownload.cse.ucsc.edu/goldenPath/hg19/database/cytoBand.txt.gz
}
\keyword{datasets}

\name{segment}
\alias{segment}
\title{Genome Segmentation Program}
\description{
  This program segments DNA copy number data into regions of estimated 
  equal copy number using circular binary segmentation (CBS).
}
\usage{
  segment(x, weights = NULL, alpha = 0.01, nperm = 10000, p.method = 
                    c("hybrid", "perm"), min.width=2, kmax=25, nmin=200, 
                    eta=0.05, sbdry=NULL, trim = 0.025, undo.splits = 
                    c("none", "prune", "sdundo"), undo.prune=0.05, 
                    undo.SD=3, verbose=1)
}
\arguments{
  \item{x}{an object of class CNA}
  \item{weights}{a vector of weights for the probes. The weights should be
    inversely proportional to their variances.  Currently all weights
    should be positive i.e. remove probes with zero weight prior to
    segmentation.}
  \item{alpha}{significance levels for the test to accept change-points.}
  \item{nperm}{number of permutations used for p-value computation.}
  \item{p.method}{method used for p-value computation.  For the "perm"
    method the p-value is based on full permutation.  For the "hybrid"
    method the maximum over the entire region is split into maximum of
    max over small segments and max over the rest.  Approximation is
    used for the larger segment max. Default is hybrid.}
  \item{min.width}{the minimum number of markers for a changed segment.
    The default is 2 but can be made larger.  Maximum possible value is
    set at 5 since arbitrary widths can have the undesirable effect of
    incorrect change-points when a true signal of narrow widths exists.}
  \item{kmax}{the maximum width of smaller segment for permutation
    in the hybrid method.}
  \item{nmin}{the minimum length of data for which the approximation of
    maximum statistic is used under the hybrid method. should be larger
    than 4*kmax}
  \item{eta}{the probability to declare a change conditioned on the
    permuted statistic exceeding the observed statistic exactly  
    j (= 1,...,nperm*alpha) times.}
  \item{sbdry}{the sequential boundary used to stop and declare a
    change. This boundary is a function of nperm, alpha and eta.  It can
    be obtained using the function "getbdry" and used instead of having
    the "segment" function compute it every time it is called.}
  \item{trim}{proportion of data to be trimmed for variance calculation
    for smoothing outliers and undoing splits based on SD.}
  \item{undo.splits}{A character string specifying how change-points are
    to be undone, if at all.  Default is "none".  Other choices are
    "prune", which uses a sum of squares criterion, and "sdundo", which 
    undoes splits that are not at least this many SDs apart.}
  \item{undo.prune}{the proportional increase in sum of squares allowed
    when eliminating splits if undo.splits="prune".}
  \item{undo.SD}{the number of SDs between means to keep a split if
    undo.splits="sdundo".}
  \item{verbose}{level of verbosity for monitoring the program's
    progress where 0 produces no printout, 1 prints the current sample,
    2 the current chromosome and 3 the current segment.  The default
    level is 1.}  
}

\value{
  An object of class \code{DNAcopy}.  It has three elements:
  \item{data}{The original CNA object which was the input for segment}
  \item{out}{a data frame with six columns.  Each row of the data frame
    contains a segment for which there are six variables: the sample id,
    the chromosome number, the map position of the start of the segment,
    the map position of the end of the segment, the number of markers in
    the segment, and the average value in the segment.}
  \item{segRows}{a data frame with the start and end row of each segment
    in the data matrix.  print command shows it with the showSegRows=T}
  \item{call}{the call that produced the output object.}
}

\details{
  This function implements the cicular binary segmentation (CBS)
  algorithm of Olshen and Venkatraman (2004).  Given a set of genomic
  data, either continuous or binary, the algorithm recursively splits
  chromosomes into either two or three subsegments based on a maximum
  t-statistic.  A reference distribution, used to decided whether or not
  to split, is estimated by permutation.  Options are given to eliminate
  splits when the means of adjacent segments are not sufficiently far
  apart.  Note that after the first split the \eqn{\alpha}-levels of the
  tests for splitting are not unconditional.

  We recommend using one of the undoing options to remove change-points
  detected due to local trends (see the manuscript below for examples of
  local trends).

  Since the segmentation procedure uses a permutation reference
  distribution, R commands for setting and saving seeds should be used
  if the user wishes to reproduce the results.

  Data that are NA, Inf, NaN will be removed on a per sample basis for
  "genomdat" and all samples for "chrom" and "maploc".  
}

\examples{

# test code on an easy data set
set.seed(25)
genomdat <- rnorm(500, sd=0.1) +
rep(c(-0.2,0.1,1,-0.5,0.2,-0.5,0.1,-0.2),c(137,87,17,49,29,52,87,42))
plot(genomdat)
chrom <- rep(1:2,c(290,210))
maploc <- c(1:290,1:210)
test1 <- segment(CNA(genomdat, chrom, maploc))

# test code on a noisier and hence more difficult data set
set.seed(51)
genomdat <- rnorm(500, sd=0.2) +
rep(c(-0.2,0.1,1,-0.5,0.2,-0.5,0.1,-0.2),c(137,87,17,49,29,52,87,42))
plot(genomdat)
chrom <- rep(1:2,c(290,210))
maploc <- c(1:290,1:210)
test2 <- segment(CNA(genomdat, chrom, maploc))

# test code for weighted CBS
set.seed(97)
wts <- sample(1:3, 500, replace=TRUE)
genomdat <- rnorm(500, sd=0.3)/sqrt(wts) +
rep(c(-0.2,0.1,1,-0.5,0.2,-0.5,0.1,-0.2),c(137,87,17,49,29,52,87,42))
plot(genomdat)
chrom <- rep(1:2,c(290,210))
maploc <- c(1:290,1:210)
test3 <- segment(CNA(genomdat, chrom, maploc), weights=wts)

#A real analyis

data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

#We generally recommend smoothing single point outliers before analysis
#Make sure to check that the smoothing is proper

smoothed.CNA.object <- smooth.CNA(CNA.object)

#Segmentation at default parameters

segment.smoothed.CNA.object <- segment(smoothed.CNA.object, verbose=1)
data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

#We generally recommend smoothing single point outliers before analysis
#Make sure to check that the smoothing is proper

smoothed.CNA.object <- smooth.CNA(CNA.object)

#Segmentation at default parameters

segment.smoothed.CNA.object <- segment(smoothed.CNA.object, verbose=1)

}

\author{Venkatraman E. Seshan \email{seshanv@mskcc.org} and Adam Olshen
  \email{olshena@biostat.ucsf.edu} } 

\references{
  Olshen, A. B., Venkatraman, E. S., Lucito, R., Wigler, M. (2004).
  Circular binary segmentation for the analysis of array-based DNA copy
  number data.  \emph{Biostatistics} 5: 557-572.

  Venkatraman, E. S., Olshen, A. B. (2007) A faster circular binary
  segmentation algorithm for the analysis of array CGH data.
  \emph{Bioinformatics} 23: 657-63.
}

\keyword{nonparametric}

\name{subset.CNA}
\alias{subset.CNA}
\title{Subset a `Copy Number Array' data object}
\description{
   Function to return a subset of a copy number array data object by a
   list of chromosomes and sample.
}
\usage{
  \method{subset}{CNA}(x, chromlist=NULL, samplelist=NULL, ...)
}                          
\arguments{
  \item{x}{Copy number array data object}
  \item{chromlist}{chromosomes of interest.  Should be a subset of the
    valid chromosome names in the original data.}
  \item{samplelist}{samples of interest.  Can be integers denoting the
    samples of interest or a vector of valid sample names.}
  \item{...}{other arguments which may be passed to \code{subset}.}
}
\value{
  An object of class \code{CNA} with the data for the list of
  chromosomes and samples of interest. 
}

\examples{

data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

#Take the first ten chromosomes of the first sample

#subset.CNA.object <- subset.CNA(CNA.object,chromlist=1:10,samplelist="c05296")
subset.CNA.object <- subset(CNA.object,chromlist=1:10,samplelist="c05296")
}

\keyword{nonparametric}

\name{CNA}
\alias{CNA}
\alias{print.CNA}
\title{Create `Copy Number Array' data object}
\description{
  Creates a `copy number array' data object used for DNA copy number
  analyses by programs such as circular binary segmentation (CBS).
}
\usage{
  CNA(genomdat, chrom, maploc, data.type=c("logratio","binary"),
                 sampleid=NULL, presorted = FALSE)
  \method{print}{CNA}(x, \dots)
}
\arguments{
  \item{genomdat}{a vector or matrix of data from array-CGH, ROMA, or
    other copy number experiments. If it is a matrix the rows correspond
    to the markers and the columns to the samples.}
  \item{chrom}{the chromosomes (or other group identifier) from which
    the markers came.  Vector of length same as the number of rows of
    genomdat.  If one wants the chromosomes to be ordered in the
    natural order, this variable should be numeric or ordered category.} 
  \item{maploc}{the locations of marker on the genome.  Vector of length
    same as the number of rows of genomdat. This has to be numeric.}
  \item{data.type}{logratio (aCGH, ROMA, etc.) or binary (LOH).}
  \item{sampleid}{sample identifier.  If missing the samples are named
    by prefixing "Sample" to consecutive integers.}
  \item{presorted}{logical indicator telling if the data have already
    been sorted by chrom and maploc.  Default is FALSE.}
  \item{x}{object returned by CNA}
  \item{...}{arguments to be passed onto print command called within.}
}
\value{
  An object of class \code{CNA}.  There is a \code{print} method that
  gives the number of samples and probes and the type of data.
}

\details{
  Data that are NA, Inf, NaN will be removed on a per sample basis for
  "genomdat" and all samples for "chrom" and "maploc".

  If the chrom variable has non-numeric values make it into an ordered
  variable to get them ordered correctly. E.g. for human genome use:
  \code{chrom <- ordered(chrom, levels=c(1:22,"X","Y"))} to prepare the
  variable if chromosomes X and Y are present in your data.
}

\examples{

data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

}

\keyword{nonparametric}

\name{DNAcopy-internal}
\alias{changepoints}
\alias{changepoints.prune}
\alias{changepoints.sdundo}
\alias{smooth.data}
\alias{trimmed.variance}
\alias{inflfact}
\alias{exon.changepoint}
\title{Internal DNAcopy functions}
\description{
  Internal functions of package DNAcopy.
}
\usage{
changepoints(genomdat, data.type = "logratio", alpha = 0.01, weights = NULL,
                 sbdry, sbn, nperm = 10000, p.method="hybrid", min.width=2,
                 kmax=25, nmin = 200, trimmed.SD = NULL, undo.splits = "none",
                 undo.prune = 0.05, undo.SD = 3, verbose = 1, ngrid=100,
                 tol=1e-6) 
changepoints.prune(genomdat, lseg, change.cutoff=0.05)
changepoints.sdundo(genomdat, lseg, trimmed.SD, change.SD=3)
trimmed.variance(genomdat, trim=0.025)
inflfact(trim)
exon.changepoint(exondat, ngrid=100, tol=1e-6)
}
\details{These are not to be called directly by the user}
\keyword{internal}

\name{DNAcopy}
\alias{DNAcopy}
\alias{print.DNAcopy}
\title{Results of segmenting a CNA data object}
\usage{
\method{print}{DNAcopy}(x, showSegRows=FALSE, \dots)
}
\description{
  The results of segmenting data from copy number array experiments from
  programs such as circular binary segmentation (CBS).
}
\arguments{
  \item{x}{an object of class \code{DNAcopy} -- output of segment.}
  \item{showSegRows}{option to show row numbers for the segment start
    and end.  default is FALSE.}
  \item{...}{arguments to be passed onto print command called within.}
}
\value{
  \item{data}{The original CNA object which was the input for segment}
  \item{ID}{sample identifier.}
  \item{chrom}{the chromosome within the sample.}
  \item{loc.start}{the starting map location of the segment}
  \item{loc.end}{the ending map location of the segment}
  \item{num.mark}{the number of markers in the segment}
  \item{data.type}{the segment mean.}
  \item{call}{the call that produced the object.}
}
\details{
  An object of class \code{DNAcopy}.  There is a \code{print} method
  that prints the results in a tabular format.  Each row gives the
  sample, the chromosome, the start and end map locations, the number of
  markers and the mean of each segment.
}
\keyword{nonparametric}

\name{segments.summary}
\alias{segments.summary}
\title{Additional summary measured for the segments}
\description{
  This program computes the standard deviation, median and the mad of
  the data for each segment found by the CBS algorithm.
}
\usage{
  segments.summary(x)
}
\arguments{
  \item{x}{an object of class DNAcopy}
}
\value{
  a data frame with nine columns.  The sd, median and mad of each
  segment is added to the six columns from the segment command.
}
\examples{

# test code on an easy data set
set.seed(25)
genomdat1 <- rnorm(500, sd=0.1) +
rep(c(-0.2,0.1,1,-0.5,0.2,-0.5,0.1,-0.2),c(137,87,17,49,29,52,87,42))
genomdat2 <- rnorm(500, sd=0.1) +
rep(c(-0.2,0.1,1,-0.5,0.2,-0.5,0.1,-0.2),c(137,87,17,49,29,52,87,42))
genomdat1[sample(1:500,5)] <- NA
chrom <- rep(1:2,c(290,210))
maploc <- c(1:290,1:210)
test1 <- segment(CNA(cbind(genomdat1,genomdat2), chrom, maploc))
segments.summary(test1)

}

\author{Venkatraman E. Seshan}

\keyword{nonparametric}

\name{plotSample}
\alias{plotSample}
\title{Plot the data and results from segmentation for a single sample}
\description{
  Plots the data for a single sample from a copy number array experiment
  (aCGH, ROMA etc.) along with the results of segmenting it into regions
  of equal copy numbers.
} 
\usage{
  plotSample(x, sampleid=NULL, chromlist=NULL, xmaploc=FALSE,
             col=c("black","green"), pch=".", cex=NULL, altcol=TRUE,
             segcol="red", lwd=3, zeroline=TRUE, zlcol="grey",
             xlab=NULL, ylab=NULL, main=NULL, ...)
}
\arguments{
  \item{x}{an object of class \code{DNAcopy} resulting from analyzing
    data from copy number array experiments.}
  \item{sampleid}{the sample for which the plot is requested.  Should be
    a valid sample name or number.  If missing the first sample is plotted.} 
  \item{chromlist}{a vector of chromosome numers or names to be plotted.
    If missing the whole genome is plotted.}
  \item{xmaploc}{a logical indicating if data are plotted against genomic
    position or Index.  Defaults to \code{FALSE}.}
  \item{col}{a vector of two colors that can be used for alternating
    colors for successive chromosomes.}
  \item{pch}{the plotting character.  Defaults to \code{.}.}
  \item{cex}{the size of plotting character.  If missing it is set to 3
    if pch is `.' and 1 otherwise.}
  \item{altcol}{a logical indicating if colors of successive chromosomes
    should be alternated.  Defaults to \code{TRUE}.}
  \item{segcol}{color for segment means.}
  \item{zeroline}{a logical indicating if the zeroline is drawn.
    Defaults to \code{TRUE}.}
  \item{zlcol}{color for zero line.}
  \item{lwd}{thickness of the lines.}
  \item{xlab}{the x-axis lavel. If missing Index or Genomic Position
    will be used depending on xmaploc.}
  \item{ylab}{the y-axis label. If missing log(CN) or LOH will be used
    depending on data type.}
  \item{main}{the main title.  If missing sample name will be used.}
  \item{...}{other arguments to the \code{plot} function can be passed here.}
}
\details{
  This function plots the whole genome and segmentation results for a single
  sample.  This function overcomes the deficiency in the plot.DNAcopy function
  which cycles through all the samples.  If sampleid is not specified the
  first sample is plotted.
}

\examples{

#Read in two examples from Snijders et al.

data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

#We generally recommend smoothing single point outliers before analysis
#Make sure to check that the smoothing is proper

smoothed.CNA.object <- smooth.CNA(CNA.object)

#Segmentation at default parameters

segment.smoothed.CNA.object <- segment(smoothed.CNA.object, verbose=1)

# Plot whole sample c13330

plotSample(segment.smoothed.CNA.object, sampleid="c13330")

# Plot only chromosomes 1,3,5,7,9 from first sample
plotSample(segment.smoothed.CNA.object, sampleid=1, chromlist=c(1,3,5,7,9))

}

\keyword{nonparametric}

\name{plot.DNAcopy}
\alias{plot.DNAcopy}
\title{Plot the data and results from segment of a CNA object}
\description{
  Plots the data from a copy number array experiment (aCGH, ROMA etc.)
  along with the results of segmenting it into regions of equal copy
  numbers.
} 
\usage{
  \method{plot}{DNAcopy}(x, plot.type=c("whole", "plateau", "samplebychrom",
               "chrombysample"), xmaploc=FALSE, altcol=TRUE, sbyc.layout=
                NULL, cbys.nchrom=1, cbys.layout=NULL, include.means=TRUE,
                zeroline=TRUE, pt.pch=NULL, pt.cex=NULL, pt.cols=NULL,
                segcol= NULL, zlcol=NULL, ylim=NULL, lwd=NULL, ...)
}
\arguments{
  \item{x}{an object of class \code{DNAcopy} resulting from analyzing
    data from copy number array experiments.}
  \item{plot.type}{the type of plot.}
  \item{xmaploc}{logical flag to indicate that the X axis is the maploc
    position rather than the index.  Since the segments are rearranged
    the plateau plot does not use maploc position.}
  \item{altcol}{logical flag to indicate if chromosomes should be
    plotted in alternating colors in the whole genome plot.}
  \item{sbyc.layout}{\code{layout} settings for the multifigure grid layout
    for the `samplebychrom' type.  It should be specified as a vector of
    two integers which are the number of rows and columns.  The default
    values are chosen based on the number of chromosomes to produce a
    near square graph.   For normal genome it is 4x6 (24 chromosomes)
    plotted by rows.}
  \item{cbys.layout}{\code{layout} settings for the multifigure grid layout
    for the `chrombysample' type.  As above it should be specified as
    number of rows and columns and the default chosen based on the
    number of samples.}
  \item{cbys.nchrom}{the number of chromosomes per page in the layout.
    The default is 1.}
  \item{include.means}{logical flag to indicate whether segment means
    are to be drawn.}
  \item{zeroline}{logical flag to indicate whether a horizontal line at
    y=0 is to be drawn.}
  \item{pt.pch}{the plotting character used for plotting the log-ratio
    values (default is ".").}
  \item{pt.cex}{the size of plotting character used for the log-ratio
    values (default is 3).}
  \item{pt.cols}{the color list for the points. The colors alternate
    between chromosomes. If missing the point colors are black and green.}
  \item{segcol}{the color of the lines indicating the segment means. If
    missing the line color is set to be red.} 
  \item{zlcol}{the color of the zeroline. If missing it is set to be grey.}
  \item{ylim}{this argument is present to override the default limits
    which is the range of symmetrized log-ratios.}
  \item{lwd}{line weight of lines for segment mean and zeroline.  If
    missing it is set to 3.}
  \item{...}{other arguments which will be passed to \code{plot}
    commands.}
}
\details{
  There are four possible plot types.  For the type `whole' the data
  are plotted for the entire genome.  For the `samplebychrom' type a
  graph with each chromosome (of a given sample) is drawn in a separate
  figure on a multi-figure grid.  For the `plateau' type the graph
  is drawn with the chromosome segments re-ordered by the segment means.
  For the `chrombysample' type the samples for a given chromosome are
  drawn in a 4x6 multi-figure grid in multiples of 24. By default the
  segments means are drawn.  For multisample data each sample or
  chromosome is drawn on a separate sheet.  When invoked interactively
  the user is prompted before advancing to the next sample. 
}

\examples{

#Read in two examples from Snijders et al.

data(coriell)

#Combine into one CNA object to prepare for analysis on Chromosomes 1-23

CNA.object <- CNA(cbind(coriell$Coriell.05296,coriell$Coriell.13330),
                  coriell$Chromosome,coriell$Position,
                  data.type="logratio",sampleid=c("c05296","c13330"))

#We generally recommend smoothing single point outliers before analysis
#Make sure to check that the smoothing is proper

smoothed.CNA.object <- smooth.CNA(CNA.object)

#Segmentation at default parameters

segment.smoothed.CNA.object <- segment(smoothed.CNA.object, verbose=1)

#Plot whole studies

plot(segment.smoothed.CNA.object, plot.type="w")

#Plot each study by chromosome

plot(segment.smoothed.CNA.object, plot.type="s")

#Plot each chromosome across studies (6 per page)

plot(segment.smoothed.CNA.object, plot.type="c", cbys.layout=c(2,1), cbys.nchrom=6)

#Plot by plateaus

plot(segment.smoothed.CNA.object, plot.type="p")

}

\keyword{nonparametric}

\name{exon.segment}
\alias{exon.segment}
\title{Binary segmentation of exon data.}
\description{
  Compute the binary segmentation statistic, location and approximate p-value.
}
\usage{
  exon.segment(gene, eloc, edat, ngrid=100, tol=1e-6)
}
\arguments{
  \item{gene}{gene names in the exon data}
  \item{eloc}{exon locations within gene}
  \item{edat}{exon expressions within gene}
  \item{ngrid}{number grid points for the integral}
  \item{tol}{tolerance level for calculating nu}
}
\value{
  a matrix with three columns.  The maximal statistic from binary
  segmentation, its location and the p-values for each gene.
}
\details{
  The p-values are obtained by applying Siegmund's approximation for the
  maximal statistic from binary segmenting consecutive segments within a
  chromosome.  These are one-sided test for an increase in expression.
}
\examples{

# test code on an easy data set
set.seed(25)
gene <- rep(c("A", "B"), c(30,20))
eloc <- c(1:30, 1:20)
edat <- matrix(rnorm(500), 50, 10)
# changes for gene1 in samples 3 & 7
edat[1:30, 3] <- edat[1:30, 3] + rep(0.9*0:1, c(17, 13))
edat[1:30, 7] <- edat[1:30, 7] + rep(1.1*0:1, c(21, 9))
# changes for gene2 in samples 4 & 7
edat[31:50, 4] <- edat[31:50, 4] + rep(1.1*0:1, c(8, 12))
edat[31:50, 7] <- edat[31:50, 7] + rep(1.2*0:1, c(13, 7))
exon.segment(gene, eloc, edat)

}

\author{Venkatraman E. Seshan}

\keyword{nonparametric}

\name{segments.p}
\alias{segments.p}
\title{p-values for the change-points}
\description{
  This program computes pseudo p-values and confidence intervals for the
  change-points found by the circular binary segmentation (CBS) algorithm.
}
\usage{
  segments.p(x, ngrid=100, tol=1e-6, alpha=0.05, search.range=100, nperm=1000)
}
\arguments{
  \item{x}{an object of class DNAcopy}
  \item{ngrid}{number grid points for the integral}
  \item{tol}{tolerance level for calculating nu}
  \item{alpha}{Confidence level is 1-alpha}
  \item{search.range}{statistic is maximized over nu +/- search.range}
  \item{nperm}{number of permutations for confidence interval} 
}
\value{
  a data frame with ten columns.  The maximal statistic from binary
  segmentation, the p-values and lower and upper alpha/2 confidence
  limits (as genomic positions) are added to the six columns from the
  segment command.

  NOTE:  THE p VALUES ARE APPROXIMATE TAIL PROBABILITIES.  ANY VALUE
  GREATER THAN 0.1 CAN HAVE LARGE ERROR.  p > 1 ARE REPLACED WITH 1.
}
\details{
  The p-values are obtained by applying Siegmund's approximation for the
  maximal statistic from binary segmenting consecutive segments within a
  chromosome.  This p-value is only to give the relative importance of
  the change-points as the CBS is different from the algorithm used here.

  The confidence intervals are obtained by a permutation algorithm.  The
  data are permuted to the left and right of the identified change-point
  and the location of the maximal binary segmentation statistic computed.
  The confidence interval is given by the quantiles of the permutation
  distribution of the locations.

  The statistical properties of this confidence interval is unknown.  It
  is used to give an idea of the uncertainity on the location of the
  change-points as the CBS is different from the algorithm used here.
}
\examples{

# test code on an easy data set
set.seed(25)
genomdat <- rnorm(500, sd=0.1) +
rep(c(-0.2,0.1,1,-0.5,0.2,-0.5,0.1,-0.2),c(137,87,17,49,29,52,87,42))
plot(genomdat)
chrom <- rep(1:2,c(290,210))
maploc <- c(1:290,1:210)
test1 <- segment(CNA(genomdat, chrom, maploc))
segments.p(test1)

}

\author{Venkatraman E. Seshan}

\keyword{nonparametric}
